/*
 * @OSF_COPYRIGHT@
 * COPYRIGHT NOTICE
 * Copyright (c) 1996 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (DCE).  See the file named COPYRIGHT.DCE in the
 * src directory for the full copyright text.
 */
/*
 * HISTORY
 * $Log: des_rw.c,v $
 * Revision 1.1.2.2  1996/10/03  14:38:21  arvind
 * 	Submit code review fixes
 * 	[1996/08/28  20:36 UTC  mullan_s  /main/DCE_1.2.2/mullan_dce122_bugs_1/1]
 *
 * 	remove unnecessary ifdefs - makes code harder to read.
 * 	[1996/05/30  21:17 UTC  mullan_s  /main/DCE_1.2.2/1]
 *
 * 	Merge krb5 work to DCE1.2.2 mainline
 * 	[1996/05/29  20:37 UTC  mullan_s  /main/mullan_dce1.2.2_krb5_drop/1]
 *
 * 	Merge krb5 work from DCE_1.2 to DCE_1.2.2
 * 	[1996/05/17  17:39 UTC  mullan_s  /main/mullan_dce_k5_bsd44_rutils/6]
 *
 * 	Change "ifdef CRYPT" to "ifndef NOENCRYPTION".
 * 	[1996/04/19  21:10 UTC  mullan_s  /main/mullan_dce_k5_bsd44_rutils/5]
 *
 * 	Add OSF/HP copyrights.
 * 	Preserve BSD4.4-lite source base via ifdefs.
 * 	Add <stdio.h> to list of include files.
 * 	[1996/04/19  21:10 UTC  mullan_s  /main/mullan_dce_k5_bsd44_rutils/5]
 *
 * Revision 1.1.2.1  1996/06/04  21:46:04  arvind
 * 	Merge krb5 work to DCE1.2.2 mainline
 * 	[1996/05/29  20:37 UTC  mullan_s  /main/mullan_dce1.2.2_krb5_drop/1]
 * 
 * 	Merge krb5 work from DCE_1.2 to DCE_1.2.2
 * 	[1996/05/17  17:39 UTC  mullan_s  /main/mullan_dce_k5_bsd44_rutils/6]
 * 
 * 	Change "ifdef CRYPT" to "ifndef NOENCRYPTION".
 * 	[1996/04/19  21:10 UTC  mullan_s  /main/mullan_dce_k5_bsd44_rutils/5]
 * 
 * 	Add OSF/HP copyrights.
 * 	Preserve BSD4.4-lite source base via ifdefs.
 * 	Add <stdio.h> to list of include files.
 * 	[1996/04/19  21:10 UTC  mullan_s  /main/mullan_dce_k5_bsd44_rutils/5]
 * 
 * $EndLog$
 */
/*-
 * Copyright (c) 1989, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
/*
** Copyright (c) Hewlett-Packard Company 1996
** Unpublished work. All Rights Reserved.
**
*
* Note on the ifdefs: KRBV implies Kerberos V support
* and was merged from the MIT krbv5 code for des read and write
* routines.
*/

#ifndef lint
static char sccsid[] = "@(#)des_rw.c	8.1 (Berkeley) 6/6/93";
#endif /* not lint */

#ifndef NOENCRYPTION
#ifdef KERBEROS
#include <sys/param.h>

#ifdef KRBV
#include "krb5.h"
#else
#include <kerberosIV/des.h>
#include <kerberosIV/krb.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>

#ifdef KRBV
extern krb5_context bsd_context;
extern krb5_encrypt_block eblock;
extern krb5_data desinbuf, desoutbuf;
#endif
static unsigned char	des_inbuf[10240], storage[10240], *store_ptr;

/*
 * NB: These routines will not function properly if NBIO
 * 	is set
 */

int
des_read(fd, buf, len)
	int fd;
	register char *buf;
	int len;
{
	int nreturned = 0;
	long net_len, rd_len;
	int nstored = 0;
#ifdef KRBV
	int cc;
#endif

	if (nstored >= len) {
		(void) bcopy(store_ptr, buf, len);
		store_ptr += len;
		nstored -= len;
		return(len);
	} else if (nstored) {
		(void) bcopy(store_ptr, buf, nstored);
		nreturned += nstored;
		buf += nstored;
		len -= nstored;
		nstored = 0;
	}

#ifdef KRBV
        {
                unsigned char c;
                int gotzero = 0;

               	/* See the comment in v4_des_read. */
               	do {
                	cc = krb5_net_read(bsd_context, fd, &c, 1);
                	/* we should check for non-blocking here, but we'd have
                   	   to make it save partial reads as well. */
                	if (cc <= 0) return 0; /* read error */
                	if (cc == 1) {
                        	if (c == 0) gotzero = 1;
                	}
                } while (!gotzero);

                if ((cc = krb5_net_read(bsd_context, fd, &c, 1)) != 1) return 0;
                rd_len = c;
                if ((cc = krb5_net_read(bsd_context, fd, &c, 1)) != 1) return 0;
                rd_len = (rd_len << 8) | c;
                if ((cc = krb5_net_read(bsd_context, fd, &c, 1)) != 1) return 0;
                rd_len = (rd_len << 8) | c;
        }
	
        net_len = krb5_encrypt_size(rd_len,eblock.crypto_entry);
        if ((net_len <= 0) || (net_len > sizeof(des_inbuf))) {
        	/* preposterous length; assume out-of-sync; only
           	   recourse is to close connection, so return 0 */
        	fprintf(stderr,"Read size problem.\n");
        	return(0);
        }
        if ((cc = krb5_net_read(bsd_context, fd, desinbuf.data, net_len)) != net_len) {
        	/* pipe must have closed, return 0 */
        	fprintf(stderr,
                        "Read error: length received %d != expected %d.\n",
                        cc,net_len);
        	return(0);
        }
        /* decrypt info */
        if ((krb5_decrypt(bsd_context, desinbuf.data,
                          (krb5_pointer) storage,
                          net_len,
                          &eblock, 0))) {
        	fprintf(stderr,"Cannot decrypt data from network.\n");
        	return(0);
        }
	store_ptr = storage;
	nstored = rd_len;
#else
        if (krb_net_read(fd, (char *)&net_len, sizeof(net_len)) !=
            sizeof(net_len)) {
                /* XXX can't read enough, pipe
                   must have closed */
                return(0);
        }
        net_len = ntohl(net_len);
        if (net_len <= 0 || net_len > sizeof(des_inbuf)) {
                /* preposterous length; assume out-of-sync; only
                   recourse is to close connection, so return 0 */
                return(0);
        }
        /* the writer tells us how much real data we are getting, but
           we need to read the pad bytes (8-byte boundary) */
        rd_len = roundup(net_len, 8);
        if (krb_net_read(fd, (char *)des_inbuf, rd_len) != rd_len) {
                /* pipe must have closed, return 0 */
                return(0);
        }
        (void) des_pcbc_encrypt(des_inbuf,      /* inbuf */
                            storage,            /* outbuf */
                            net_len,            /* length */
                            key_schedule,       /* DES key */
                            key,                /* IV */
                            DECRYPT);           /* direction */

        if(net_len < 8)
                store_ptr = storage + 8 - net_len;
        else
                store_ptr = storage;

        nstored = net_len;
#endif
	if (nstored > len) {
		(void) bcopy(store_ptr, buf, len);
		nreturned += len;
		store_ptr += len;
		nstored -= len;
	} else {
		(void) bcopy(store_ptr, buf, nstored);
		nreturned += nstored;
		nstored = 0;
	}
	
	return(nreturned);
}

static	unsigned char des_outbuf[10240];	/* > longest write */

int
des_write(fd, buf, len)
	int fd;
	char *buf;
	int len;
{
#ifdef KRBV
        unsigned char len_buf[4];
#else
        static  int     seeded = 0;
        static  char    garbage_buf[8];
        long net_len, garbage;
#endif

#ifdef KRBV
        desoutbuf.length = krb5_encrypt_size(len,eblock.crypto_entry);
        if (desoutbuf.length > sizeof(des_outbuf)){
            fprintf(stderr,"Write size problem.\n");
            return(-1);
        }
        if (( krb5_encrypt(bsd_context, (krb5_pointer)buf,
                           desoutbuf.data,
                           len,
                           &eblock,
                           0))){
            fprintf(stderr,"Write encrypt problem.\n");
            return(-1);
        }

        len_buf[0] = (len & 0xff000000) >> 24;
        len_buf[1] = (len & 0xff0000) >> 16;
        len_buf[2] = (len & 0xff00) >> 8;
        len_buf[3] = (len & 0xff);
        (void) write(fd, len_buf, 4);
        if (write(fd, desoutbuf.data,desoutbuf.length) != desoutbuf.length){
	        fprintf(stderr,"Could not write out all data.\n");
        	return(-1);
        }
    else return(len);
#else
        if(len < 8) {
                if(!seeded) {
                        seeded = 1;
                        srandom((int) time((long *)0));
                }
                garbage = random();
                /* insert random garbage */
                (void) bcopy(&garbage, garbage_buf, MIN(sizeof(long),8));
                /* this "right-justifies" the data in the buffer */
                (void) bcopy(buf, garbage_buf + 8 - len, len);
        }
        /* pcbc_encrypt outputs in 8-byte (64 bit) increments */

        (void) des_pcbc_encrypt((len < 8) ? garbage_buf : buf,
                            des_outbuf,
                            (len < 8) ? 8 : len,
                            key_schedule,       /* DES key */
                            key,                /* IV */
                            ENCRYPT);

        /* tell the other end the real amount, but send an 8-byte padded
           packet */
        net_len = htonl(len);
        (void) write(fd, &net_len, sizeof(net_len));
        (void) write(fd, des_outbuf, roundup(len,8));
        return(len);
#endif
}
#endif /* KERBEROS */
#endif /* NOENCRYPTION */
