/*
 * @OSF_COPYRIGHT@
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993, 1996 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (DCE).  See the file named COPYRIGHT.DCE in the
 * src directory for the full copyright text.
 */
/*
 * HISTORY
 * $Log: ecb_encrypt.c,v $
 * Revision 1.1.8.2  1996/02/17  23:59:41  marty
 * 	Update OSF copyright years
 * 	[1996/02/17  22:53:15  marty]
 *
 * Revision 1.1.8.1  1995/12/08  00:13:33  root
 * 	Submit OSF/DCE 1.2.1
 * 
 * 	HP revision /main/HPDCE02/1  1995/08/22  21:58 UTC  sommerfeld
 * 	take out what-string.
 * 	[1995/08/22  20:33 UTC  sommerfeld  /main/sommerfeld_mothpatch/1]
 * 
 * Revision 1.1.6.1  1994/01/21  22:30:54  cbrooks
 * 	Code Cleanup
 * 	[1994/01/21  20:20:55  cbrooks]
 * 
 * Revision 1.1.4.3  1993/01/03  22:34:40  bbelch
 * 	Embedding copyright notice
 * 	[1993/01/03  19:49:49  bbelch]
 * 
 * Revision 1.1.4.2  1992/12/23  19:35:44  zeliff
 * 	Embedding copyright notice
 * 	[1992/12/23  01:15:27  zeliff]
 * 
 * Revision 1.1.2.2  1992/05/01  17:36:29  rsalz
 * 	"Changed pas part of rpc6 drop."
 * 	[1992/05/01  17:34:10  rsalz]
 * 
 * Revision 1.1  1992/01/19  03:16:57  devrcs
 * 	Initial revision
 * 
 * $EndLog$
 */
/*
*/

/*  ecb_encrypt.c V=2 01/09/91 //crown/prgy/krb5/lib/destoo
**
** Copyright (c) Hewlett-Packard Company 1991
** Unpublished work. All Rights Reserved.
**
**    ** OSF DCE Confidential - DCE Security Component BL 6   **
**    ** OSF DCE AUTH 3 - prerelease                          **
**
*/
/*
 * Copyright (c) 1990 Dennis Ferguson.  All rights reserved.
 *
 * Commercial use is permitted only if products which are derived from
 * or include this software are made available for purchase and/or use
 * in Canada.  Otherwise, redistribution and use in source and binary
 * forms are permitted.
 */

/*
 * des_ecb_encrypt.c - do an encryption in ECB mode
 */
#include <dce/dce.h>
#include <des.h>
#include <des_tables.h>

/*
 * des_ecb_encrypt - {en,de}crypt a block in ECB mode
 */
int
des_ecb_encrypt
#ifdef _DCE_PROTO_
    (
	des_cblock *in,
	des_cblock *out,
	des_key_schedule schedule,
	int encrypt
    )
#else 
    (in, out, schedule, encrypt)
	des_cblock *in;
	des_cblock *out;
	des_key_schedule schedule;
	int encrypt;
#endif /* _DCE_PROTO_ */
{
	register unsigned long left, right;
	register unsigned long temp;
	register int i;

	{
		/*
		 * Need a temporary for copying the data in
		 */
		register unsigned char *datap;

		/*
		 * Copy the input block into the registers
		 */
		datap = (unsigned char *)in;
		GET_HALF_BLOCK(left, datap);
		GET_HALF_BLOCK(right, datap);
	}

	/*
	 * Do the initial permutation.
	 */
	DES_INITIAL_PERM(left, right, temp);

	/*
	 * Now the rounds.  Use different code depending on whether it
	 * is an encryption or a decryption (gross, should keep both
	 * sets of keys in the key schedule instead).
	 */
	if (encrypt) {
		register unsigned long *kp;

		kp = (unsigned long *)schedule;
		for (i = 0; i < 8; i++) {
			DES_SP_ENCRYPT_ROUND(left, right, temp, kp);
			DES_SP_ENCRYPT_ROUND(right, left, temp, kp);
		}
	} else {
		register unsigned long *kp;

		/*
		 * Point kp past end of schedule
		 */
		kp = ((unsigned long *)schedule) + (2 * 16);;
		for (i = 0; i < 8; i++) {
			DES_SP_DECRYPT_ROUND(left, right, temp, kp);
			DES_SP_DECRYPT_ROUND(right, left, temp, kp);
		}
	}

	/*
	 * Do the final permutation
	 */
	DES_FINAL_PERM(left, right, temp);

	/*
	 * Finally, copy the result out a byte at a time
	 */
	{
		register unsigned char *datap;

		datap = (unsigned char *)out;
		PUT_HALF_BLOCK(left, datap);
		PUT_HALF_BLOCK(right, datap);
	}

	/*
	 * return nothing
	 */
	return (0);
}
