/*
 * @OSF_COPYRIGHT@
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993, 1996 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (DCE).  See the file named COPYRIGHT.DCE in the
 * src directory for the full copyright text.
 */
/*
 * HISTORY
 * $Log: krbcn.c,v $
 * Revision 1.1.108.3  1996/08/09  12:02:52  arvind
 * 	Merge code review cleanup from mb_u2u2
 * 	[1996/07/03  19:28 UTC  burati  /main/DCE_1.2.2/mb_u2u2/1]
 *
 * 	u2u cleanup (rtn for checking u2u status code)
 * 	[1996/06/14  21:23 UTC  burati  /main/DCE_1.2.2/2]
 *
 * 	Use KRB5KDC_ERR_MUST_USE_USER2USER instead of KRB5KDC_ERR_POLICY
 * 	[1996/04/29  20:52 UTC  burati  /main/DCE_1.2/mb_u2u/1]
 *
 * 	merge u2u work
 * 	[1996/04/29  20:08 UTC  burati  /main/HPDCE02/mb_mothra8/1]
 *
 * 	u2u work off Mothra, before 1.2 branch is available
 * 	Fetch Svr TGT on refresh if necessary.
 * 	[1996/01/03  19:02 UTC  psn  /main/DCE_1.2/1]
 *
 * Revision 1.1.108.2  1996/07/08  18:23:47  arvind
 * 	Use KRB5KDC_ERR_MUST_USE_USER2USER instead of KRB5KDC_ERR_POLICY
 * 	[1996/04/29  20:52 UTC  burati  /main/DCE_1.2/mb_u2u/1]
 * 
 * 	merge u2u work
 * 	[1996/04/29  20:08 UTC  burati  /main/HPDCE02/mb_mothra8/1]
 * 
 * 	u2u work off Mothra, before 1.2 branch is available
 * 	Fetch Svr TGT on refresh if necessary.
 * 	[1996/01/03  19:02 UTC  psn  /main/DCE_1.2/1]
 * 
 * Revision 1.1.108.1  1996/06/04  21:54:58  arvind
 * 	u2u: Merge fetchof svr TGT on refresh, if necessary, in
 * 	rpc__krb_cn_cred_refresh().
 * 	[1996/05/06  20:23 UTC  burati  /main/DCE_1.2/2]
 * 
 * 	merge u2u work
 * 	[1996/04/29  20:52 UTC  burati  /main/DCE_1.2/mb_u2u/1]
 * 
 * 	u2u work off Mothra, before 1.2 branch is available
 * 	Fetch Svr TGT on refresh if necessary.
 * 	[1996/04/29  20:08 UTC  burati  /main/HPDCE02/mb_mothra8/1]
 * 
 * 	Remove Mothra specific code
 * 	[1995/11/16  21:33 UTC  jrr  /main/HPDCE02/jrr_1.2_mothra/1]
 * 
 * 	Merge fix for CN alter_context security context negotiation
 * 	[1995/04/19  01:31 UTC  lmm  /main/HPDCE02/3]
 * 
 * 	Fixed CN alter_context security context negotiation.
 * 	[1995/04/18  18:21 UTC  tatsu_s  /main/HPDCE02/tatsu_s.cn_sec_fix.b0/1]
 * 
 * 	Merge allocation failure detection functionality into Mothra
 * 	[1995/04/02  01:15 UTC  lmm  /main/HPDCE02/2]
 * 
 * 	add memory allocation failure detection
 * 	[1995/04/02  00:19 UTC  lmm  /main/HPDCE02/lmm_rpc_alloc_fail_detect/1]
 * 
 * 	Submitted the local rpc security bypass.
 * 	[1995/03/06  17:20 UTC  tatsu_s  /main/HPDCE02/1]
 * 
 * 	Local RPC Security Bypass.
 * 	[1995/02/22  22:32 UTC  tatsu_s  /main/tatsu_s.local_rpc.b1/1]
 * 
 * Revision 1.1.106.2  1996/02/18  00:04:23  marty
 * 	Update OSF copyright years
 * 	[1996/02/17  22:56:41  marty]
 * 
 * Revision 1.1.106.1  1995/12/08  00:20:39  root
 * 	Submit OSF/DCE 1.2.1
 * 
 * 	HP revision /main/HPDCE02/jrr_1.2_mothra/1  1995/11/16  21:33 UTC  jrr
 * 	Remove Mothra specific code
 * 
 * 	HP revision /main/HPDCE02/3  1995/04/19  01:31 UTC  lmm
 * 	Merge fix for CN alter_context security context negotiation
 * 
 * 	HP revision /main/HPDCE02/tatsu_s.cn_sec_fix.b0/1  1995/04/18  18:21 UTC  tatsu_s
 * 	Fixed CN alter_context security context negotiation.
 * 
 * 	HP revision /main/HPDCE02/2  1995/04/02  01:15 UTC  lmm
 * 	Merge allocation failure detection functionality into Mothra
 * 
 * 	HP revision /main/HPDCE02/lmm_rpc_alloc_fail_detect/1  1995/04/02  00:19 UTC  lmm
 * 	add memory allocation failure detection
 * 
 * 	HP revision /main/HPDCE02/1  1995/03/06  17:20 UTC  tatsu_s
 * 	Submitted the local rpc security bypass.
 * 
 * 	HP revision /main/tatsu_s.local_rpc.b1/1  1995/02/22  22:32 UTC  tatsu_s
 * 	Local RPC Security Bypass.
 * 	[1995/12/07  23:59:32  root]
 * 
 * Revision 1.1.104.13  1994/09/21  19:07:37  sommerfeld
 * 	[OT10413] on client, retain & check timestamps for CN mutual authentication.
 * 	[1994/09/21  19:05:37  sommerfeld]
 * 
 * Revision 1.1.104.12  1994/07/06  20:26:56  sommerfeld
 * 	[OT11176] Fix CN to use AUTHZ_PROTO_V1_1 when appropriate.
 * 	[1994/07/06  20:18:51  sommerfeld]
 * 
 * Revision 1.1.104.11  1994/06/21  21:54:08  hopkins
 * 	Merge up to DCE1_1.
 * 	[1994/06/08  21:32:46  hopkins]
 * 
 * 	More serviceability
 * 	[1994/06/06  21:13:37  hopkins]
 * 
 * Revision 1.1.104.10  1994/06/02  22:04:40  mdf
 * 	Merged with changes from 1.1.104.9
 * 	[1994/06/02  22:04:05  mdf]
 * 
 * 	Merged with changes from 1.1.104.7
 * 	[1994/06/02  19:08:26  mdf]
 * 
 * 	hp_sec_to_osf_3 drop, merge up with latest.
 * 	[1994/05/24  15:12:53  mdf]
 * 
 * 	hp_sec_to_osf_3 drop, merge up with latest.
 * 
 * Revision 1.1.104.7  1994/05/19  21:14:51  hopkins
 * 	Merge with DCE1_1.
 * 	[1994/05/04  19:42:21  hopkins]
 * 
 * 	Serviceability work.
 * 	[1994/05/03  20:22:11  hopkins]
 * 
 * Revision 1.1.104.6  1994/03/17  23:06:46  tom
 * 	Big PAC:
 * 	  Set status return in fmt_client_req.
 * 	  Fix up void pointer arithmetic again (9752).
 * 	  Add old_server flag to fmt_client_req, return error if pac too big.
 * 	[1994/03/17  23:04:42  tom]
 * 
 * Revision 1.1.104.5  1994/01/28  23:09:30  burati
 * 	EPAC changes - Add support for creds to krb_info->auth_info (dlg_bl1)
 * 	[1994/01/25  04:01:13  burati]
 * 
 * Revision 1.1.104.4  1994/01/21  22:37:48  cbrooks
 * 	RPC Code Cleanyp - Initial Submission
 * 	[1994/01/21  21:58:07  cbrooks]
 * 
 * Revision 1.1.104.2  1994/01/17  17:02:26  tom
 * 	Bug 9752 - Can't do arithmetic on void pointers.
 * 	[1994/01/17  16:59:28  tom]
 * 
 * Revision 1.1.104.1  1994/01/14  20:31:29  tom
 * 	Big PAC (server side)
 * 	  Modify fmt server resp to copy as much as will fit of the
 * 	  KRB_AP_RESP message and save it for sending later.
 * 	[1994/01/13  22:55:18  tom]
 * 
 * 	Big PAC - Add arguments to rpc__krb_cn_fmt_client_req.
 * 	[1993/11/09  15:04:58  tom]
 * 
 * Revision 1.1.8.1  1993/09/23  19:55:43  ganni
 * 	OT8638: All the rpc_c_authn_level_pkt_privacy code need to be provided
 * 	under #ifndef NOENCRYPTION. (due to export regulations).
 * 	[1993/09/23  19:54:44  ganni]
 * 
 * Revision 1.1.6.2  1993/06/24  20:18:44  hinman
 * 	[hinman] - Save merged-in SNI version (these files have been freed of nasty code)
 * 	[1993/06/17  14:24:23  hinman]
 * 
 * Revision 1.1.4.7  1993/03/25  19:09:14  wei_hu
 * 	           23-mar-93   wei_hu  Initialize the condition variable
 * 	                               when we allocate the krb_info struct.
 * 	[1993/03/23  19:56:47  wei_hu]
 * 
 * Revision 1.1.4.6  1993/03/05  19:20:46  weisman
 * 	      10-jan-93 burton    change rpc_g_krb_cn_epv from GLOBAL
 * 	                          to INTERNAL and removed undef of INTERNAL
 * 	[1993/03/05  19:09:17  weisman]
 * 
 * Revision 1.1.4.5  1993/01/03  23:25:50  bbelch
 * 	Embedding copyright notice
 * 	[1993/01/03  20:07:51  bbelch]
 * 
 * Revision 1.1.4.4  1992/12/23  20:51:43  zeliff
 * 	Embedding copyright notice
 * 	[1992/12/23  15:39:37  zeliff]
 * 
 * Revision 1.1.4.3  1992/12/18  19:56:43  wei_hu
 * 	      09-dec-92 raizen    Modify auth_info refcount to fix memory leak
 * 	[1992/12/18  19:46:28  wei_hu]
 * 
 * Revision 1.1.4.2  1992/10/13  20:55:57  weisman
 * 	           16-sep-92   ko      Remove rpc__krb_cn_get_tkt
 * 	                               Remove rpc__krb_cn_cred_valid
 * 	                               Add rpc__krb_cn_cred_changed
 * 	                               Add rpc__krb_cn_cred_refresh
 * 	           21-aug-92   wh      Change lock ordering in rpc__krb_cn_
 * 	                               get_tkt to eliminate a deadlock between
 * 	                               krb_info and CN global mutex.
 * 	[1992/10/13  20:48:01  weisman]
 * 
 * Revision 1.1.2.7  1992/08/18  20:08:28  sekhar
 * 	           18-aug-92   wh      Changed locking logic in krb_cn_get_tkt
 * 	                               to eliminate potential dealock dealing
 * 	                               with cred fetching and ticket renewal.
 * 	[1992/08/18  20:07:46  sekhar]
 * 
 * Revision 1.1.2.6  1992/07/28  20:22:40  rsalz
 * 	      28-jul-92   wh      Removed erroneous lock_assert of krb_info.
 * 	                          Make the refresh code call krb_cn_get_tkt,
 * 	                          which observes the CN lock hierarchy.
 * 	                          Added krb_cn_get_tkt.
 * 	[1992/07/28  20:22:12  rsalz]
 * 
 * Revision 1.1.2.5  1992/06/02  21:30:32  rsalz
 * 	      02-jun-92   wh      Byte-swap the crc if needed.
 * 	[1992/06/02  21:29:39  rsalz]
 * 
 * Revision 1.1.2.4  1992/05/28  20:19:03  rsalz
 * 	Do some byteswapping of association, for interoperability fixes.
 * 	[1992/05/28  20:17:11  rsalz]
 * 
 * Revision 1.1.2.3  1992/05/22  18:58:11  wei_hu
 * 	 06-may-1992 sp      Conditionally compile encryption calls.
 * 	                     Put *encrypt_crc function inline instead
 * 	                     of making it a separate callable routine
 * 	                     (security reasons - we don't want to give
 * 	                     user direct access to a des encryption routine).
 * 	 01-may-1992 sp      Fix ansi compiler errors.
 * 	 23-mar-1992 sp      Add support for md checksum.  Add missing code
 * 	                     to copy session key.
 * 	 19-mar-1992 sp      Endian changes.
 * 	 18-mar-1992 pf      Fix typo
 * 	 17-mar-1992 sp      Initial Version
 * 	[1992/05/22  18:44:50  wei_hu]
 * 
 * $EndLog$
 */
/*
**  Copyright (c) 1991 by
**      Hewlett-Packard Company, Palo Alto, Ca. & 
**      Digital Equipment Corporation, Maynard, Mass.
**
**
**  NAME
**
**      krbcn.c
**
**  FACILITY:
**
**      Remote Procedure Call (RPC) 
**
**  ABSTRACT:
**
**  The Kerberos CN authentication module.
**
**
*/

#include <commonp.h>
#include <com.h>
#include <ndrp.h>
#include <cnp.h>
#include <krbp.h>
#include <krbcn.h>

#include <dce/assert.h>


INTERNAL boolean32 rpc__krb_cn_three_way _DCE_PROTOTYPE_((void));


INTERNAL boolean32 rpc__krb_cn_context_valid _DCE_PROTOTYPE_((
        rpc_cn_sec_context_p_t           /*sec*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_create_info _DCE_PROTOTYPE_((
       rpc_authn_level_t                 /*authn_level*/,
       rpc_auth_info_p_t                * /*auth_info*/,
       unsigned32                       * /*st*/
    ));

INTERNAL boolean32 rpc__krb_cn_cred_changed _DCE_PROTOTYPE_((
        rpc_cn_sec_context_p_t           /*sec*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_cred_refresh _DCE_PROTOTYPE_((
        rpc_auth_info_p_t                /*auth_info*/,
        rpc_binding_handle_t             /*h*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_fmt_client_req _DCE_PROTOTYPE_((
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        rpc_cn_sec_context_p_t           /*sec*/,
        pointer_t                        /*auth_value*/,
        unsigned32                      * /*auth_value_len*/,
        pointer_t                       * /* last_auth_pos */,
        unsigned32                      * /* auth_len_remain */,
        unsigned32                        /* old_server */,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_fmt_srvr_resp _DCE_PROTOTYPE_((
        unsigned32                       /*verify_st*/,
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        rpc_cn_sec_context_p_t           /*sec*/,
        pointer_t                        /*req_auth_value*/,
        unsigned32                       /*req_auth_value_len*/,
        pointer_t                        /*auth_value*/,
        unsigned32                      * /*auth_value_len*/
    ));

INTERNAL void rpc__krb_cn_free_prot_info _DCE_PROTOTYPE_((
        rpc_auth_info_p_t                /*info*/,
        rpc_cn_auth_info_p_t            * /*cn_info*/
    ));

INTERNAL void rpc__krb_cn_get_prot_info _DCE_PROTOTYPE_((
        rpc_auth_info_p_t                /*info*/,
        rpc_cn_auth_info_p_t            * /*cn_info*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_pre_call _DCE_PROTOTYPE_((
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        rpc_cn_sec_context_p_t           /*sec*/,
        pointer_t                        /*auth_value*/,
        unsigned32                      * /*auth_value_len*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_pre_send _DCE_PROTOTYPE_((
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        rpc_cn_sec_context_p_t           /*sec*/,
        rpc_socket_iovec_p_t             /*iov*/,
        unsigned32                       /*iovlen*/,
        rpc_socket_iovec_p_t             /*out_iov*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_recv_check _DCE_PROTOTYPE_((
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        rpc_cn_sec_context_p_t           /*sec*/,
        rpc_cn_common_hdr_p_t            /*pdu*/,
        unsigned32                       /*pdu_len*/,
        unsigned32                       /*cred_len*/,
        rpc_cn_auth_tlr_p_t              /*auth_tlr*/,
        boolean32                        /*unpack_ints*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_tlr_uuid_crc _DCE_PROTOTYPE_((
        pointer_t                /*auth_value*/,
        unsigned32               /*auth_value_len*/,
        unsigned32              * /*uuid_crc*/
    ));

INTERNAL void rpc__krb_cn_tlr_unpack _DCE_PROTOTYPE_((
        rpc_cn_packet_p_t        /*pkt_p*/,
        unsigned32               /*auth_value_len*/,
        unsigned8               * /*packed_drep*/
    ));

INTERNAL void rpc__krb_cn_vfy_client_req _DCE_PROTOTYPE_((
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        rpc_cn_sec_context_p_t           /*sec*/,
        pointer_t                        /*auth_value*/,
        unsigned32                       /*auth_value_len*/,
        unsigned32			 /*old_client*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_vfy_srvr_resp _DCE_PROTOTYPE_((
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        rpc_cn_sec_context_p_t           /*sec*/,
        pointer_t                        /*auth_value*/,
        unsigned32                       /*auth_value_len*/,
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_coalesce_fragbufs _DCE_PROTOTYPE_((
        rpc_socket_iovec_p_t             /*iov*/,
        unsigned32                       /*iovlen*/,
        rpc_socket_iovec_p_t             /*out_iov*/
    ));

#define RPC_CN_TRANSMIT  TRUE
#define RPC_CN_RECEIVE   FALSE 

INTERNAL void rpc__krb_cn_compute_ivec _DCE_PROTOTYPE_((
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        boolean32                        /*is_transmitter*/,
        boolean32                        /*is_server*/,
        sec_des_block                   * /*ivec*/
    ));

INTERNAL boolean32 rpc__krb_cn_des_cksum_eq _DCE_PROTOTYPE_((
        sec_des_block                   * /*checksum1*/,
        sec_des_block                   * /*checksum2*/
    ));

INTERNAL boolean32 rpc__krb_cn_md_cksum_eq _DCE_PROTOTYPE_((
        idl_byte                        * /*checksum1*/,
        idl_byte                        * /*checksum2*/
    ));

INTERNAL void rpc__krb_cn_inq_cksum_algorithm _DCE_PROTOTYPE_((
        unsigned32                      * /*st*/
    ));

INTERNAL void rpc__krb_cn_compute_md5_cksm _DCE_PROTOTYPE_((
        byte_p_t                         /*plaintext*/,
        unsigned32                       /*plaintext_len*/,
        sec_des_block                   * /*encrypted_crc*/,
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        boolean32                        /*is_transmitter*/,
        boolean32                        /*is_server*/,
        idl_byte                        * /*checksum*/
    ));

INTERNAL void rpc__krb_cn_privacy_encode_pkt _DCE_PROTOTYPE_((
	rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
	rpc_cn_sec_context_p_t           /*sec*/,
	rpc_socket_iovec_p_t             /*iov*/,
	unsigned32                       /*iovlen*/,
	rpc_socket_iovec_p_t             /*out_iov*/
    ));

INTERNAL void rpc__krb_cn_privacy_decode_pkt _DCE_PROTOTYPE_((
        rpc_cn_assoc_sec_context_p_t     /*assoc_sec*/,
        rpc_cn_sec_context_p_t           /*sec*/,
	rpc_cn_packet_p_t                /*pdu*/,
        unsigned32                       /*pdu_len*/,
        rpc_cn_auth_tlr_p_t              /*auth_tlr*/,
        boolean32                        /*unpack_ints*/,
        unsigned32                      * /*st*/
    ));

#ifdef SNI_PRIVATE
#endif /* SNI_PRIVATE */

extern rpc_clock_unix_t rpc_g_clock_unix_curr;

GLOBAL unsigned32 rpc_g_krb_cn_sub_type;

INTERNAL rpc_cn_auth_epv_t rpc_g_krb_cn_epv =
{
    rpc__krb_cn_three_way,
    rpc__krb_cn_context_valid,   /* pointers assignment compatible */
    rpc__krb_cn_create_info,
    rpc__krb_cn_cred_changed,
    rpc__krb_cn_cred_refresh,
    rpc__krb_cn_fmt_client_req,
    rpc__krb_cn_fmt_srvr_resp,
    rpc__krb_cn_free_prot_info,
    rpc__krb_cn_get_prot_info,
    rpc__krb_cn_pre_call,
    rpc__krb_cn_pre_send,
    rpc__krb_cn_recv_check,
    rpc__krb_cn_tlr_uuid_crc,
    rpc__krb_cn_tlr_unpack,
    rpc__krb_cn_vfy_client_req,
    rpc__krb_cn_vfy_srvr_resp
};

static sec_des_block zero_block = { 0,0,0,0,0,0,0,0 };
static idl_byte md_zero_block[16] = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_three_way
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Determine whether the authentication protocol requires a
**      3-way authentication handshake. If true the client is expected to
**      provide an rpc_auth3 PDU before the security context is fully
**      established and a call can be made.
**
**  INPUTS:             none
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            none
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     boolean32
**
**      True if the authentication protocol requires a 3-way
**      authentication handshake.
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL boolean32 rpc__krb_cn_three_way (void)
{
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_three_way)\n"));


    return (false);
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_context_valid
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Determine whether the established security context will be
**      valid (i. e. timely) for the next 300 seconds. If
**      not this routine will try to renew the context.
**      If it cannot be renewed false is returned. This is
**      called from the client side.
**
**  INPUTS:
**
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     boolean32
**
**      True if security context identified by the auth
**      information rep and RPC auth information rep will
**      still be valid in 300 seconds, false if not.
**
**  SIDE EFFECTS:       
**
**      The context may be renewed.
**
**--
**/

INTERNAL boolean32 rpc__krb_cn_context_valid 
(
    rpc_cn_sec_context_p_t          sec,
    unsigned32                      *st
)
{
    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_context_valid)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_context_valid) prot->%x level->%x key_id->%x\n",
                    rpc_c_authn_dce_private,
                    sec->sec_info->authn_level,
                    sec->sec_key_id));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_CONTEXT_VALID))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return (false);
    }
#endif

    *st = rpc_s_ok;
    return (true);
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_create_info
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Create an auth information rep data structure.
**      This is called on the server side.
**      The fields will be initialized to NULL values.
**      The caller should fill them in based on information
**      decrypted from the authenticator passed in the bind
**      request.
**
**  INPUTS:
**
**      authn_level     The authentication level to be applied over this
**                      security context.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      info            A pointer to the auth information rep structure
**                      containing RPC protocol indenpendent information.
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_create_info 
(
    rpc_authn_level_t                authn_level,
    rpc_auth_info_p_t                *auth_info,
    unsigned32                       *st
)
{
    rpc_krb_info_p_t krb_info;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_create_info)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_create_info) prot->%x level->%x\n",
                    rpc_c_authn_dce_private,
                    authn_level));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_CREATE_INFO))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif

    /*
     * Allocate storage for a krb info structure from heap.
     */
    RPC_MEM_ALLOC (krb_info, 
                   rpc_krb_info_p_t, 
                   sizeof (rpc_krb_info_t), 
                   RPC_C_MEM_KRB_INFO, 
                   RPC_C_MEM_WAITOK);
    if (krb_info == NULL){
	*st = rpc_s_no_memory;
	return;
    }

    /*
     * Initialize it.
     */
    memset (krb_info, 0, sizeof(rpc_krb_info_t));
    RPC_MUTEX_INIT (krb_info->lock);
    RPC_COND_INIT (krb_info->cond, krb_info->lock);

    /*
     * Initialize the common auth_info stuff.
     */
    krb_info->auth_info.refcount = 0;
    krb_info->auth_info.server_princ_name = '\0';
    krb_info->auth_info.authn_level = authn_level;
    krb_info->auth_info.authn_protocol = rpc_c_authn_dce_private;
    krb_info->auth_info.authz_protocol = rpc_c_authz_name;
    krb_info->auth_info.is_server = true;

    *auth_info = (rpc_auth_info_t *) krb_info;
    *st = rpc_s_ok;
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_cred_changed
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Determine whether the client's credentials stored in the
**      security context are different from those in the auth info.
**      If they are not the same return true, else false.
**
**  INPUTS:
**
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     boolean32
**
**      True if the credentials identified by the auth
**      information rep and RPC auth information rep are different,
**      false if not.
**
**      The md5 checksum algorithm requires the use of the session key
**      to encrypt the CRC(assoc_uuid).  Since the session key will 
**      change when the credential changes, this routine sets the flag
**      indicating that a (potentially) valid encrypted crc is now 
**      invalid, forcing a recomputation.
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL boolean32 rpc__krb_cn_cred_changed 
(
    rpc_cn_sec_context_p_t          sec,
    unsigned32                      *st
)
{
    rpc_krb_cn_info_t           *krb_cn_info;
    rpc_krb_info_p_t            krb_info;
    boolean32                   different_creds;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_cred_changed)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_cred_changed) prot->%x level->%x key_id->%x\n",
                    rpc_c_authn_dce_private,
                    sec->sec_info->authn_level,
                    sec->sec_key_id));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_CRED_CHANGED))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return (false);
    }
#endif

    /*
     * Assume that cred is already valid.
     */
    *st = rpc_s_ok;
    krb_info = (rpc_krb_info_p_t) sec->sec_info;
    krb_cn_info = (rpc_krb_cn_info_p_t)sec->sec_cn_info;
    RPC_KRB_INFO_LOCK(krb_info);
    different_creds = memcmp (&krb_cn_info->expiration, 
                              &krb_info->expiration,
                              sizeof (krb_info->expiration)) != 0;

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_auth,
                      RPC_C_CN_DBG_AUTH_REFRESH))
    {
        RPC_DBG_PRINTF(rpc_e_dbg_auth, 1,
	    ("(rpc__krb_cn_cred_changed) krb_info exp=%d krb_cn_info exp=%d ", 
            krb_cn_info->expiration, krb_info->expiration));
    }
#endif

    /*
     * If the credentials have been refreshed copy the new ones into
     * the security context. Make sure the expiration time of the
     * refreshed credentials is also copied. Mark the encrypted CRC in
     * the security context as being invalid since the credentials
     * have changed.
     */
    if (different_creds)
    {
        krb_cn_info->cred = krb_info->cred;
        krb_cn_info->expiration = krb_info->expiration;
#ifdef DEBUG
        if (RPC_DBG_EXACT(rpc_es_dbg_auth,
                          RPC_C_CN_DBG_AUTH_REFRESH))
        {
            RPC_DBG_PRINTF(rpc_e_dbg_auth, 1,
		("creds changed and have been copied\n"));
        }
#endif
        RPC_DBG_PRINTF(rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_GENERAL,
                       ("(rpc__krb_cn_cred_changed) creds copied new exp=%d\n", 
                        krb_cn_info->expiration));

        krb_cn_info->encrypted_crc_valid = false;
    }
#ifdef DEBUG
    else
    {
        if (RPC_DBG_EXACT(rpc_es_dbg_auth,
                          RPC_C_CN_DBG_AUTH_REFRESH))
        {
            RPC_DBG_PRINTF(rpc_e_dbg_auth, 1,
		("creds have not changed\n"));
        }
    }
#endif

    RPC_KRB_INFO_UNLOCK(krb_info);
    return (different_creds);
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_cred_refresh
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Determine whether the client's credentials are still
**      valid. If not this routine will try to renew the credentials.
**      If they cannot be renewed an error is returned. This routine
**      is called from the client side. 
**
**      Caveat:
**
**      This routine must not be called with any CN locks held since
**      the process of renewing a credential may involve making a CN RPC
**      call to the KDC server.
**
**  INPUTS:
**
**      auth_info       A pointer to the auth information rep
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       
**
**      The credentials may be refreshed.
**      krb_cn_info->encrypted_crc_valid set to false 
**      if credentials were refreshed.
**
**--
**/

INTERNAL void rpc__krb_cn_cred_refresh 
(
    rpc_auth_info_p_t               auth_info,
    rpc_binding_handle_t            h,
    unsigned32                      *st
)
{
    rpc_krb_info_p_t            krb_info;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_cred_refresh)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_cred_refresh) prot->%x level->%x\n",
                    rpc_c_authn_dce_private,
                    auth_info->authn_level));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_CRED_REFRESH))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif

    /*
     * Assume that cred is already valid.
     */
    *st = rpc_s_ok;

    krb_info = (rpc_krb_info_p_t) auth_info;
    RPC_KRB_INFO_LOCK (krb_info);
#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_auth,
                      RPC_C_CN_DBG_AUTH_REFRESH))
    {
        RPC_DBG_PRINTF(rpc_e_dbg_auth, 1,
	    ("(rpc__krb_cn_cred_refresh) system time=%d krb_info exp time=%d ", 
            rpc_g_clock_unix_curr, krb_info->expiration));
    }
#endif

    if (rpc__clock_unix_expired (krb_info->expiration)
        &&
        (krb_info->auth_info.authn_level != rpc_c_authn_level_none))
    {
        /* 
         * We need to refresh the creds in krb_info 
         */
        krb_info->creds_valid = 0;
        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_GENERAL,
                        ("(rpc__krb_cn_cred_refresh) trying to refresh tickets; old exp=%d\n",
                         krb_info->expiration));
        *st = rpc__krb_get_tkt(krb_info);
        if (*st != rpc_s_ok) 
        {
            RPC_DBG_GPRINTF(("(rpc__krb_cn_cred_refresh) rpc__krb_get_tkt failed: st %x\n",
                             *st));
#ifdef DEBUG
            if (RPC_DBG_EXACT(rpc_es_dbg_auth,
                              RPC_C_CN_DBG_AUTH_REFRESH))
            {
        	RPC_DBG_PRINTF(rpc_e_dbg_auth, 1,
                    (" creds refresh failed st=%x\n", *st));
            }
#endif

#ifndef PRE_U2U
            /* NEW FOR U2U
             * If we get a NEVER_VALID error, it means the Svr TGT we
             * used for U2U has expired according to the KDC time, and
             * we need to fetch a new one.
             * 
             * If we got a policy error and aren't already trying u2u,
             * it means we must attempt to use the user to user protocol
             * to get the ticket.
             */
            if (sec_krb_never_valid(*st) ||
                (sec_krb_must_use_u2u(*st) &&
		 (krb_info->tgt_length == 0) &&
                 (krb_info->auth_info.authn_protocol >=
                     rpc_c_authn_dce_secret)) ) {
                unsigned32 tgt_length, tmp_st;
                unsigned_char_p_t tgt_data_p, server_princ_name;
                rpc_binding_handle_t tmp_h;

                /* Throw out old svr TGT if we have one */
                if (krb_info->tgt_data != NULL) {
                    RPC_MEM_FREE (krb_info->tgt_data, RPC_C_MEM_STRING);
                    krb_info->tgt_data = NULL;
       	            krb_info->tgt_length = 0;
                }

                /* Need copy of handle for unauth retrieval of TGT */
                rpc_binding_copy(h, &tmp_h, st);
                if (*st != rpc_s_ok) {
                    RPC_DBG_GPRINTF((
                        "(rpc__krb_cn_cred_refresh) rpc_binding_copy failed: *st %x\n",
                        *st));
                } else {

                    rpc_binding_set_auth_info(tmp_h, NULL,
                        rpc_c_protect_level_none, rpc_c_authn_none, NULL,
                        rpc_c_authz_none, &tmp_st);

                    /* Attempt to retrieve the TGT data from the server */
                    rpc_mgmt_inq_svr_princ_name_tgt(tmp_h,
                        krb_info->auth_info.authn_protocol,
                        &server_princ_name, &tgt_length, &tgt_data_p, st);
                    if (*st == rpc_s_ok) {
                        krb_info->tgt_length = tgt_length;
                        krb_info->tgt_data = tgt_data_p;

                        RPC_MEM_FREE (server_princ_name, RPC_C_MEM_STRING);

                        /* Try it again now that we have the 2nd ticket data */
                        *st = rpc__krb_get_tkt (krb_info);
			if (*st == rpc_s_ok) {
                            if (RPC_DBG_EXACT(rpc_es_dbg_auth,
                                  RPC_C_CN_DBG_AUTH_REFRESH)) {
                                RPC_DBG_PRINTF(rpc_e_dbg_auth, 1,
                                    (" u2u creds refreshed new exp time=%d\n",
                                    krb_info->expiration));
                            }
                            RPC_DBG_PRINTF(rpc_e_dbg_auth,
                                RPC_C_CN_DBG_AUTH_GENERAL,
                                ("(rpc__krb_cn_cred_refresh) new u2u exp=%d\n",
                                krb_info->expiration));
                        }
                    }
                    rpc_binding_free(&tmp_h, &tmp_st);
                }
            }
#endif /* ifndef PRE_U2U */

        }
#ifdef DEBUG
        else
        {
            if (RPC_DBG_EXACT(rpc_es_dbg_auth,
                              RPC_C_CN_DBG_AUTH_REFRESH))
            {
        	RPC_DBG_PRINTF(rpc_e_dbg_auth, 1,
                    (" creds refreshed new exp time=%d\n", krb_info->expiration));
            }
            RPC_DBG_PRINTF(rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_GENERAL,
                           ("(rpc__krb_cn_cred_refresh) new exp=%d\n", 
                            krb_info->expiration));
        }
#endif
    }
#ifdef DEBUG
    else
    {
        if (RPC_DBG_EXACT(rpc_es_dbg_auth,
                          RPC_C_CN_DBG_AUTH_REFRESH))
        {
            RPC_DBG_PRINTF(rpc_e_dbg_auth, 1,
                (" creds ok\n", *st));
        }
    }
#endif

    RPC_KRB_INFO_UNLOCK(krb_info);
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_fmt_client_req
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will format the auth_value field of
**      either an rpc_bind or rpc_alter_context PDU. This is
**      called from the client side association state machine.
**
**      For Kerberos, this means an KRB_AP_REQ message will be built and
**      placed into the credentials field of the auth_value.
**
**      We will place as much of the security info as we can in to
**      the area provided.  If it's not going to fit, we save state in
**      last_auth_pos and auth_len_remain, and expect to be called again.
**      We preserve the start of the message in the assoc_sec structure.
**
**      The choice of checksum algorithm and the corresponding checksum
**      length is placed into the sec_context structure by this routine.
**      Note that strictly speaking, this isn't necessary on the client
**      side since we could just use the global variable directly.
**      However, this is not the case on the server side, and life is
**      made a bit easier by having parallel data structures in both
**      the client and server.
**
**  INPUTS:
**
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      auth_value      A pointer to the auth_value field in the rpc_bind or
**                      rpc_alter_context PDU authentication trailer.
**      old_server      Flag that indicates we are talking to an old
**                      (RPC 5.0) server.  Return packet full if creds
**                      wont fit in one packet.
**
**  INPUTS/OUTPUTS:     
**
**      auth_value_len  On input, the length, in bytes of the available space
**                      for the auth_value field. On output, the length in
**                      bytes used in encoding the auth_value field. Zero if
**                      an error status is returned.
**
**      last_auth_pos   On input (if non-NULL), the place where we left
**                      off in copying the auth info.  On output, where
**                      we expect to continue.
**
**      auth_len_remain The number of bytes remaining to be copyed.
**                      
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_fmt_client_req 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    pointer_t                       auth_value,
    unsigned32                      *auth_value_len,
    pointer_t                       *last_auth_pos,
    unsigned32                      *auth_len_remain,
    unsigned32                      old_server,
    unsigned32                      *st
)
{
    rpc_krb_info_t                      *krb_info;
    rpc_cn_bind_auth_value_priv_t       *priv_auth_value;
    unsigned32                          priv_auth_value_len;
    unsigned32                          REQ_length;
    sec_krb_message                     *krb_ap_req_ptr;
    sec_des_key                         key;
    rpc_krb_cn_info_t                   *krb_cn_info;
    unsigned32                          assoc_uuid_crc_little_endian;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_fmt_client_req)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
                    ("(rpc__krb_cn_fmt_client_req) prot->%x level->%x key_id->%x assoc_uuid_crc->%x xmit_seq->%x recv_seq->%x\n",
                    rpc_c_authn_dce_private,
                    sec->sec_info->authn_level,
                    sec->sec_key_id,
                    assoc_sec->assoc_uuid_crc,
                    assoc_sec->assoc_next_snd_seq,
                    assoc_sec->assoc_next_rcv_seq));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_FMT_CLIENT_REQ))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif

    /*
     * We store the kerberos request in the association security
     * structure for safe keeping accross multiple calls
     */
    krb_ap_req_ptr = &assoc_sec->krb_message;
    krb_cn_info = (rpc_krb_cn_info_p_t)sec->sec_cn_info;

    if (*last_auth_pos == NULL) 
    {
        /*
         * Place checksum info into the sec_context structure.
         */
        krb_cn_info->auth_subtype = rpc_g_krb_cn_sub_type;
        krb_cn_info->auth_cksm_len = RPC_C_CN_DCE_MD5_CKSM_LEN;
        if (rpc_g_krb_cn_sub_type == RPC_C_CN_DCE_SUB_TYPE)
        {
            krb_cn_info->auth_cksm_len = RPC_C_CN_DCE_CKSM_LEN;
        }

        /*
         * Build the KRB_AP_REQ message. This is what will go in the
         * credentials field of the auth value.
         */
        krb_info = (rpc_krb_info_t *)sec->sec_info;
        krb_ap_req_ptr->data = NULL;
        *st = sec_krb_cn_build_message (krb_info->auth_info.u.auth_identity,
                                        krb_cn_info->cred,
                                        krb_info->auth_info.authn_level,
                                        krb_info->auth_info.authz_protocol,
					old_server?SEC_AUTHZ_FMT_V1_0:
					SEC_AUTHZ_FMT_V1_1,
                                        &key,
					&krb_cn_info->u.client.ctime,
					&krb_cn_info->u.client.cusec,
                                        krb_ap_req_ptr);

        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
            ("(rpc__krb_cn_fmt_client_req) Built KRB_AP_REQ message: 0x%x\n",
             krb_ap_req_ptr));

	if (*st != rpc_s_ok)
	{
            RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
        ("(rpc__krb_cn_fmt_client_req) Building KRB_AP_REQ message FAILED\n"));

	    sec_krb_message_free (krb_ap_req_ptr);
	    return;
	}
	    
	*last_auth_pos = krb_ap_req_ptr->data;
	*auth_len_remain = krb_ap_req_ptr->length;
    
        /*
         * Any authentication level except none will include a
         * KRB_AP_REQ in the credentials field. Encoding this
         * results in the session key being derived.
         */
        if (krb_info->auth_info.authn_level != rpc_c_authn_level_none)
        {
            /*
             * Save the session key that we obtained by calling
             * sec_krb_cn_build_message.  This will be used by
             * "pre_send" and "recv_check" when computing checksums.
             */
            krb_cn_info->key = key;
            *st = sec_des_key_sched (&krb_cn_info->key, 
                                     krb_cn_info->key_sched);
    
            if (*st == rpc_s_ok)
            {
                /*
                 * Compute the encrypted CRC(assoc_uuid) if the current one
                 * is invalid and we're using md5 checksums.
                 */
                if ((rpc_g_krb_cn_sub_type == RPC_C_CN_DCE_SUB_TYPE_MD5) &&
                    (!krb_cn_info->encrypted_crc_valid))
                {
                    assoc_uuid_crc_little_endian = assoc_sec->assoc_uuid_crc;
                    if (NDR_LOCAL_INT_REP != ndr_c_int_little_endian)
                    {
    	                SWAB_INPLACE_32 (assoc_uuid_crc_little_endian);
                    }
                    sec_des_cbc_cksum ((sec_des_block *)
                                       &assoc_uuid_crc_little_endian, 
                                       &krb_cn_info->encrypted_crc,
                                       sizeof(assoc_sec->assoc_uuid_crc),
                                       krb_cn_info->key_sched, 
                                       &zero_block);   /* ivec = 0 */
                    krb_cn_info->encrypted_crc_valid = true;
                }
            }
            else
            {
                sec_krb_message_free (krb_ap_req_ptr);
                return;
            }
        } /* if authn_level != none */

    } /* if last_auth_pos == NULL */

    /*
     * Compute the size of the auth value field for kerberos. The
     * variable parts are the credentials and checksum.
     */
    priv_auth_value_len = 
        RPC_CN_PKT_SIZEOF_BIND_AUTH_VAL +
	*auth_len_remain +
	krb_cn_info->auth_cksm_len;
    
    /*
     * Check the auth value length passed in to make sure the
     * Kerberos auth value encoding will fit.
     */
    if (*auth_value_len < priv_auth_value_len)
    {
        /*
         * Not enough space to encode the entire auth value. 
         */
        if (old_server)		/* RPC v5.0 server */
        {
            *st = rpc_s_credentials_too_large;

            sec_krb_message_free (krb_ap_req_ptr);
            RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
            ("(rpc__krb_cn_fmt_client_req) Returning Credentials too large\n"));
            RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
             ("(rpc__krb_cn_fmt_client_req) Freeing KRB_AP_REQ message: 0x%x\n",
              krb_ap_req_ptr));

            return;
        }

        /*
	 * Return length will equal input length (use it all).
	 * Have to save bytes at the end for the checksum.
         */

	REQ_length = *auth_value_len - 
	     (krb_cn_info->auth_cksm_len + RPC_CN_PKT_SIZEOF_BIND_AUTH_VAL);

	*auth_len_remain -= REQ_length;

        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
                       ("(rpc__krb_cn_fmt_client_req) Security too big: Available=%u, Requested=%u, REQ_length=%u, auth_len_remain=%u\n",
		    *auth_value_len,
		    priv_auth_value_len,
		    REQ_length,
		    *auth_len_remain));
    }
    else
    {
        /*
         * The whole thing will fit in this packet.
         */

        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
                       ("(rpc__krb_cn_fmt_client_req) Security Fits: Available=%u, Requested=%u, REQ_length=%u, auth_len_remain=%u\n",
		    *auth_value_len,
		    priv_auth_value_len,
		    *auth_len_remain, 0));

        *auth_value_len = priv_auth_value_len;
	REQ_length = *auth_len_remain;
	*auth_len_remain = 0;
    }

    /*
     * Encode the auth value. The actual checksum, if
     * required, will be computed later when "pre_send" is called.
     */
    priv_auth_value = (rpc_cn_bind_auth_value_priv_t *)auth_value;
    priv_auth_value->assoc_uuid_crc = assoc_sec->assoc_uuid_crc;
    priv_auth_value->sub_type = rpc_g_krb_cn_sub_type;
    priv_auth_value->checksum_length = krb_cn_info->auth_cksm_len;

    /*
     * Lastly copy section of the KRB_AP_REQ into the credentials field of
     * the auth value.
     */
    memcpy (priv_auth_value->credentials, *last_auth_pos, REQ_length);
    priv_auth_value->cred_length = REQ_length;
    *last_auth_pos = (char *)(*last_auth_pos) + REQ_length;

    /*
     * Everything went OK
     */
    *st = rpc_s_ok;

    /*
     * If the KRB_AP_REQ message all fit, free it.
     */
    if (*auth_len_remain == 0)
    {
        sec_krb_message_free (krb_ap_req_ptr);
        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
             ("(rpc__krb_cn_fmt_client_req) Freeing KRB_AP_REQ message: 0x%x\n",
              krb_ap_req_ptr));
    }
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_fmt_srvr_resp
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will format the auth_value field of
**      either an rpc_bind_ack or rpc_alter_context_response
**      PDU. The authentication protocol encoding in the
**      credentials field of auth_value should correspond
**      to the status returned from rpc__auth_cn_vfy_
**      client_req()  routine. This credentials field, when
**      decoded by rpc__auth_cn_vfy_srvr_resp(),  should
**      result in the same error code being returned. 
**      This is called from the server side association state machine.
**
**      For Kerberos, this means an KRB_AP_REP or KRB_ERROR message will
**      be built and placed into the credentials field of the auth_value.
**
**      We preserve the message in the assoc structure in case
**      it doesn't all fit in this packet.  The actions which
**      send the packet will finish sending the credentials.
**
**  INPUTS:
**
**      verify_st       The status code returned by rpc__auth_cn_verify_
**                      client_req() or some other failure which
**                      occured while trying to set up resources for
**                      the security context. 
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      req_auth_value  A pointer to the auth_value field in the
**                      rpc_bind or rpc_alter_context PDU authentication trailer.
**      req_auth_value_len The length, in bytes, of the
**                      req_auth_value field.
**      auth_value      A pointer to the auth_value field in the rpc_bind_ack or
**                      rpc_alter_context_response PDU authentication trailer.
**
**  INPUTS/OUTPUTS:     
**
**      auth_value_len  On input, the length, in bytes of the available space
**                      for the auth_value field. On output, the length in
**                      bytes used in encoding the auth_value field. Zero if
**                      an error status is returned.
**
**  OUTPUTS:            none
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_fmt_srvr_resp 
(
    unsigned32                      verify_st,
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    pointer_t                       req_auth_value,
    unsigned32                      req_auth_value_len,
    pointer_t                       auth_value,
    unsigned32                      *auth_value_len
)
{
    rpc_krb_info_t                      *krb_info;
    rpc_krb_cn_info_t                   *krb_cn_info;
    rpc_cn_bind_auth_value_priv_t       *priv_auth_value;
    unsigned32                          priv_auth_value_len;
    unsigned32                          resp_length;
    unsigned32                          st;
    sec_krb_message                     *krb_message_ptr;
    boolean                             free_message;

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_fmt_srvr_resp)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_fmt_srvr_resp) prot->%x level->%x key_id->%x assoc_uuid_crc->%x xmit_seq->%x recv_seq->%x, vfy_client_st->%x\n",
                    rpc_c_authn_dce_private,
                    sec->sec_info->authn_level,
                    sec->sec_key_id,
                    assoc_sec->assoc_uuid_crc,
                    assoc_sec->assoc_next_snd_seq,
                    assoc_sec->assoc_next_rcv_seq,
                    verify_st));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_FMT_SERVER_RESP))
    {
        verify_st = RPC_S_CN_DBG_AUTH_FAILURE;
    }
#endif

    /*
     * A KRB_ERROR message will be sent if any error has occured.
     * Otherwise KRB_AP_REP message will be sent in the credentials
     * field of the auth_value.
     */
    assert (*auth_value_len >= RPC_CN_PKT_SIZEOF_BIND_AUTH_VAL);
    krb_info = (rpc_krb_info_t *)sec->sec_info;
    krb_cn_info = (rpc_krb_cn_info_t *)sec->sec_cn_info;
    priv_auth_value = (rpc_cn_bind_auth_value_priv_t *)auth_value;
    /*
     * We stash the message in the association in case we have to
     * break it apart across mutiple PDU's.
     */
    krb_message_ptr = &assoc_sec->krb_message;
    krb_message_ptr->data = NULL;
    st = verify_st;
    if (verify_st == rpc_s_ok)
    {
        /* 
         * Format a KRB_AP_REP message.
         */
        st = sec_krb_cn_build_rep_message (krb_info->auth_info.authn_level,
                                           krb_cn_info->u.server.ctime, 
                                           krb_cn_info->u.server.cusec,
                                           krb_message_ptr, 
                                           &(krb_cn_info->key));

        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
            ("(rpc__krb_cn_fmt_srvr_resp) Built KRB_AP_REP message: 0x%x\n",
             krb_message_ptr));

    }

    /*
     * Send a KRB_ERROR message back if either:
     * 1) the KRB_AP_REQ message did not verify or
     * 2) the KRB_AP_REP message could not be built
     */
    if (st != rpc_s_ok)
    {
        /*
         * Format an error message. If the authn level is anything
         * other than none a KRB_ERROR message is formatted. If the
         * level is none a 4-byte status code is marshalled into the
         * credentials field.
         */
        st = sec_krb_cn_build_err_message (krb_info->auth_info.authn_level,
                                           st,
                                           krb_cn_info->u.server.ctime, 
                                           krb_cn_info->u.server.cusec,
                                           krb_message_ptr,
                                           NULL); 

        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
            ("(rpc__krb_cn_fmt_srvr_resp) Built KRB_ERROR message: 0x%x\n",
             krb_message_ptr));

        if (st != rpc_s_ok)
        {
	    /*
	     * rpc_m_errmsg_toobig
	     * "(%s) Error message will not fit in packet"
	     */
	    RPC_DCE_SVC_PRINTF ((
		DCE_SVC(RPC__SVC_HANDLE, "%s"),
		rpc_svc_auth,
		svc_c_sev_warning,
		rpc_m_errmsg_toobig,
		"rpc__krb_cn_fmt_srvr_response" ));
        }
    }

    /*
     * Compute the size of the auth value field for kerberos. The
     * variable parts are the credentials and checksum.
     */
    priv_auth_value_len = 
        RPC_CN_PKT_SIZEOF_BIND_AUTH_VAL +
        krb_message_ptr->length +
        krb_cn_info->auth_cksm_len;

    /*
     * Check the auth value length to make sure the message
     * will fit in the space provided.
     */
    if (*auth_value_len < priv_auth_value_len)
    {
        /*
         * Not enough space.
         * Put as much as we can in, the rest will get sent
         * after this packet goes out.  Leave enough space for
         * a header and the 'pre_send' routine to add a checksum.
         * Return length will equal input length.
         */
        resp_length = *auth_value_len - 
             (krb_cn_info->auth_cksm_len + RPC_CN_PKT_SIZEOF_BIND_AUTH_VAL);
        free_message = false;
        
        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
                  ("(rpc__krb_cn_fmt_srvr_resp) Security too big: Available=%u, Requested=%u, resp_length=%u\n",
                    *auth_value_len,
                    priv_auth_value_len,
                    resp_length));
    }
    else
    {
        /*
         * The whole thing will fit in this packet.
         */
        
        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
                       ("(rpc__krb_cn_fmt_srvr_resp) Security Fits: Available=%u, Requested=%u, resp_length=%u\n",
                    *auth_value_len,
                    priv_auth_value_len,
                    krb_message_ptr->length));

        *auth_value_len = priv_auth_value_len;
        resp_length = krb_message_ptr->length;
        free_message = true;
    }

    /*
     * Encode the auth value. The actual checksum, if
     * required, will be computed later when "pre_send" is called.
     */
    priv_auth_value->assoc_uuid_crc = assoc_sec->assoc_uuid_crc;
    priv_auth_value->sub_type = rpc_g_krb_cn_sub_type;
    priv_auth_value->checksum_length = krb_cn_info->auth_cksm_len;
    priv_auth_value->cred_length = resp_length;

    /*
     * Lastly copy the KRB_AP_REP or KRB_ERROR message into the
     * credentials field of the auth value.
     */
    memcpy (priv_auth_value->credentials, krb_message_ptr->data, resp_length);

    /*
     * The KRB message will be freed after we send it all.
     */
    if (free_message)
    {
        sec_krb_message_free (krb_message_ptr);

        RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_BIG_PAC,
             ("(rpc__krb_cn_fmt_srvr_resp) Freeing KRB message: 0x%x\n",
              krb_message_ptr));
    }
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_free_prot_info
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will free an NCA Connection RPC auth
**      information rep.
**
**  INPUTS:             
**
**      info            A pointer to the auth information rep structure
**                      containing RPC protocol indenpendent information.
**
**  INPUTS/OUTPUTS:     
**
**      cn_info         A pointer to the RPC auth information rep structure
**                      containing NCA Connection specific
**                      information. NULL on output. 
**
**  OUTPUTS:            none
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_free_prot_info 
(
    rpc_auth_info_p_t               info,    
    rpc_cn_auth_info_p_t            *cn_info
)
{
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_free_prot_info)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_free_prot_info) prot->%x level->%x \n",
                    rpc_c_authn_dce_private,
                    info->authn_level));

#ifdef DEBUG
    memset (*cn_info, 0, sizeof (rpc_cn_auth_info_t));
#endif

    RPC_MEM_FREE (*cn_info, RPC_C_MEM_KRB_CN_INFO);
    *cn_info = NULL;
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_get_prot_info
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will create and return an NCA Connection
**      RPC auth information rep.
**
**  INPUTS:
**
**      info            A pointer to the auth information rep structure
**                      containing RPC protocol indenpendent information.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      cn_info         A pointer to the RPC auth information rep structure
**                      containing NCA Connection specific information.
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_get_prot_info 
(
    rpc_auth_info_p_t               info,
    rpc_cn_auth_info_p_t            *cn_info,
    unsigned32                      *st
)
{
    rpc_krb_cn_info_t        *krb_cn_info;
    rpc_krb_info_p_t         krb_info;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_get_prot_info)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_get_prot_info) prot->%x level->%x \n",
                    rpc_c_authn_dce_private,
                    info->authn_level));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_GET_PROT_INFO))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif

    /*
     * Allocate storage for a krb cn info structure from heap.
     */
    RPC_MEM_ALLOC (krb_cn_info, 
                   rpc_krb_cn_info_p_t, 
                   sizeof (rpc_krb_cn_info_t), 
                   RPC_C_MEM_KRB_CN_INFO, 
                   RPC_C_MEM_WAITOK);
    if (krb_cn_info == NULL){
	*st = rpc_s_no_memory;
	return;
    }

    /*
     * Initialize it.
     */
    memset (krb_cn_info, 0, sizeof(rpc_krb_cn_info_t));

    krb_cn_info->encrypted_crc_valid = false;
    krb_info = (rpc_krb_info_t *)info;
    krb_cn_info->cred = krb_info->cred;
    krb_cn_info->expiration = krb_info->expiration;

    *cn_info = (rpc_cn_auth_info_t *)krb_cn_info;
    *st = rpc_s_ok;
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_pre_call
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will format the auth_value field of
**      a call level PDU, namely an rpc_request, rpc_response
**      rpc_fault, rpc_remote_alert or rpc_orphaned PDU. It will
**      also format the auth_value field of the association level
**      rpc_shutdown PDU. This does not include generating any 
**      checksums in the auth_value_field or encrypting of data 
**      corresponding to the authentication level. That will be 
**      done in the rpc__auth_cn_pre_send routine. 
**      This is called on both client and server when the data
**      structures and header template for a call are being set up.
**
**  INPUTS:
**
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      auth_value      A pointer to the auth_value field in the rpc_bind or
**                      rpc_alter_context PDU authentication trailer.
**
**  INPUTS/OUTPUTS:     
**
**      auth_value_len  On input, the length, in bytes of the available space
**                      for the auth_value field. On output, the length in
**                      bytes used in encoding the auth_value field. Zero if
**                      an error status is returned.
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_pre_call 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    pointer_t                       auth_value,
    unsigned32                      *auth_value_len,
    unsigned32                      *st
)
{
    rpc_cn_auth_value_priv_t    *priv_auth_value;
    rpc_krb_cn_info_t           *krb_cn_info;

    CODING_ERROR(st);

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_pre_call)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_pre_call) prot->%x level->%x key_id->%x assoc_uuid_crc->%x xmit_seq->%x recv_seq->%x\n",
                    rpc_c_authn_dce_private,
                    sec->sec_info->authn_level,
                    sec->sec_key_id,
                    assoc_sec->assoc_uuid_crc,
                    assoc_sec->assoc_next_snd_seq,
                    assoc_sec->assoc_next_rcv_seq));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_PRE_CALL))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif /* D_E_B_U_G */

    krb_cn_info = (rpc_krb_cn_info_p_t)sec->sec_cn_info;

    /*
     * The checksum is present only if auth level is packet or
     * higher.  (Note that call is automatically upgraded to
     * packet if it's level call.)
     */
#define RPC_CN_PRIVACY_PAD_LEN 12

    if (sec->sec_info->authn_level == rpc_c_authn_level_pkt_privacy)
    {
        /*
         * For auth_level privacy, we need to reserve
         * additional space for the null padding, the pad byte,
         * and the CRC.
         * In the worst case, this can be 7 pad bytes, 1 pad_len
         * byte, plus 4 bytes for the crc.
         *
         * We return this value so that the CN code would not 
         * create a packet which exceeded max transmit frag size.
         */
        if (*auth_value_len < 
            (RPC_CN_PKT_SIZEOF_AUTH_VAL_CKSM + krb_cn_info->auth_cksm_len +
             RPC_CN_PRIVACY_PAD_LEN))
        {
            *st = rpc_s_credentials_too_large;
            return;
        }
	else
	{
            *auth_value_len = RPC_CN_PKT_SIZEOF_AUTH_VAL_CKSM +
                              krb_cn_info->auth_cksm_len + 
			      RPC_CN_PRIVACY_PAD_LEN;
	}
    }
    else if (sec->sec_info->authn_level >= rpc_c_authn_level_call)
    {
        if (*auth_value_len < (RPC_CN_PKT_SIZEOF_AUTH_VAL_CKSM +
			       krb_cn_info->auth_cksm_len))
        {
            *st = rpc_s_credentials_too_large;
            return;
        }
        else
        {
            *auth_value_len = RPC_CN_PKT_SIZEOF_AUTH_VAL_CKSM +
                              krb_cn_info->auth_cksm_len;
        }
    }
    else
    {
        if (*auth_value_len < RPC_CN_PKT_SIZEOF_AUTH_VAL)
        {
            *st = rpc_s_credentials_too_large;
            return;
        }
        else
        {
            *auth_value_len = RPC_CN_PKT_SIZEOF_AUTH_VAL;
        }
    }

    priv_auth_value = (rpc_cn_auth_value_priv_t *)auth_value;
    priv_auth_value->sub_type = rpc_g_krb_cn_sub_type;

    /*
     * A checksum is present on call level packets only if
     * the authentication level is level_call or higher.
     */
    if (sec->sec_info->authn_level >= rpc_c_authn_level_call)
	priv_auth_value->checksum_length = krb_cn_info->auth_cksm_len;
    else
	priv_auth_value->checksum_length = 0;

    *st = rpc_s_ok;
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_pre_send
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will perform per-packet security
**      processing on a packet before it is sent. This
**      includes checksumming and encryption.
**
**      Note that in some cases, the data is copied to
**      a contiguous buffer for checksumming and 
**      encryption.  In these cases, the contiguous
**      iov element should be used instead of the original 
**      iovector.
**
**      The algorithms for determining the checksums for the
**      various auth levels are described in the "Network
**      Computing Architecture Remote Procedure Call RunTime
**      Extensions Specification" aka "the architecture spec."
**
**  INPUTS:
**
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      iov             A pointer to the iovector containing the PDU
**                      about to be sent. The appropriate per-packet security
**                      services will be applied to it. 
**      iovlen          The length of the iov.
**      out_iov         An iovector element.  This iovector element
**                      will describe packet if the original iov
**                      had to be copied.  If the original iov was
**                      copied, out_iov->base will be non-NULL.
**                      The caller should free out_iov->base.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_pre_send 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    rpc_socket_iovec_p_t            iov,
    unsigned32                      iovlen,
    rpc_socket_iovec_p_t            out_iov,
    unsigned32                      *st
)
{
    unsigned32                      ptype;
    rpc_authn_level_t               authn_level;
    rpc_cn_auth_tlr_p_t             auth_tlr;
    rpc_cn_auth_value_priv_p_t      auth_value;
    rpc_cn_bind_auth_value_priv_p_t bind_auth_value;
    unsigned32                      msg_size;
    sec_des_block                   ivec;
    sec_des_block                   *checksum_ptr;
    unsigned8                       *byte_ptr;
    rpc_krb_cn_info_t               *krb_cn_info;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_pre_send)\n"));

    ptype = ((rpc_cn_common_hdr_t *)(iov[0].base))->ptype;
    krb_cn_info = (rpc_krb_cn_info_p_t)sec->sec_cn_info;
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_GENERAL,
                    ("(rpc__krb_cn_pre_send) authn level->%x packet type->%x\n", sec->sec_info->authn_level, ptype));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_pre_send) prot->%x level->%x key_id->%x assoc_uuid_crc->%x xmit_seq->%x recv_seq->%x ptype->%x\n",
                    rpc_c_authn_dce_private,
                    sec->sec_info->authn_level,
                    sec->sec_key_id,
                    assoc_sec->assoc_uuid_crc,
                    assoc_sec->assoc_next_snd_seq,
                    assoc_sec->assoc_next_rcv_seq,
                    ptype));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_PRE_SEND))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif

    authn_level = sec->sec_info->authn_level;
    out_iov->base = NULL;

    /*
     * The authentication trailer is the last iov element.
     */
    if (iovlen == 1)
    {
        auth_tlr = RPC_CN_PKT_AUTH_TLR (((rpc_cn_packet_t *) iov[0].base), iov[0].len);
    }
    else
    {
        auth_tlr = (rpc_cn_auth_tlr_p_t) (iov[iovlen-1].base);
    }

    switch ((int)ptype)
    {
        case RPC_C_CN_PKT_REQUEST:
        case RPC_C_CN_PKT_RESPONSE:
        case RPC_C_CN_PKT_FAULT:
        case RPC_C_CN_PKT_SHUTDOWN:
        case RPC_C_CN_PKT_REMOTE_ALERT:
        case RPC_C_CN_PKT_ORPHANED:
        {
            switch ((int)authn_level)
            {
                case rpc_c_authn_level_none:
                case rpc_c_authn_level_connect:
                {
                    /*
                     * Do nothing in this case.
                     * The key_id & sub_type fields have been
                     * filled in by pre_call.
                     */
                    break;
                }

                case rpc_c_authn_level_call:
                case rpc_c_authn_level_pkt:
                {
                    /*
                     * Compute checksum based on IV and sequence
                     * number, dummy zero-block.
                     */
                    auth_value = (rpc_cn_auth_value_priv_p_t) 
                        (auth_tlr->auth_value);
                    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
                    {
                        rpc__krb_cn_compute_ivec (assoc_sec, 
                            RPC_CN_TRANSMIT,
                            (boolean32) sec->sec_info->is_server,
                            &ivec);
                        sec_des_cbc_cksum (&zero_block, 
                            (sec_des_block *) auth_value->checksum,
                            sizeof(zero_block),     /* better be 8 */
                            krb_cn_info->key_sched, 
                            &ivec);
                    }
                    else
                    {
                        rpc__krb_cn_compute_md5_cksm (
                            (byte_p_t) md_zero_block, 
                            sizeof(md_zero_block), 
                            &(krb_cn_info->encrypted_crc),
                            assoc_sec, 
                            RPC_CN_TRANSMIT,
                            sec->sec_info->is_server,
                            (idl_byte*)(auth_value->checksum));
                    }

                    break;
                }

                case rpc_c_authn_level_pkt_integrity:
                {
                    /*
                     * Compute checksum over the entire message,
                     * excluding the checksum field itself.
                     * Note that this code assumes that frag_len
                     * has been updated by the caller of pre_call;
                     * i.e., it includes the checksum also.
                     */
                    msg_size = ((rpc_cn_common_hdr_t *)(iov[0].base))
                                ->frag_len - 
                               krb_cn_info->auth_cksm_len;

                    /*
                     * Copy all the fragbufs into a contiguous buffer.
                     */
                    rpc__krb_cn_coalesce_fragbufs (iov, iovlen, out_iov);
		    if (out_iov->base == NULL){
			*st = rpc_s_no_memory;
			return;
		    }

                    /*
                     * Index to the checksum field in the contiguous
                     * buffer.
                     */
                    auth_tlr = RPC_CN_PKT_AUTH_TLR (
                               (rpc_cn_packet_t *) out_iov->base, 
                               out_iov->len);
                    auth_value = (rpc_cn_auth_value_priv_t *)
                               (auth_tlr->auth_value);
                    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
                    {
                        rpc__krb_cn_compute_ivec (assoc_sec, 
                            RPC_CN_TRANSMIT,
                            (boolean32) sec->sec_info->is_server,
                            &ivec);
                        sec_des_cbc_cksum (
                            (sec_des_block *) out_iov->base, 
                            (sec_des_block *) auth_value->checksum,
                            msg_size,
                            krb_cn_info->key_sched, 
                            &ivec);
                    }
                    else
                    {
                        rpc__krb_cn_compute_md5_cksm (
                            (byte_p_t) out_iov->base, 
                            msg_size, 
                            &(krb_cn_info->encrypted_crc),
                            assoc_sec, 
                            RPC_CN_TRANSMIT,
                            sec->sec_info->is_server,
                            (idl_byte*) auth_value->checksum);
                    }

                    break;
                }

#ifndef NOENCRYPTION
                case rpc_c_authn_level_pkt_privacy:
		{
		    rpc__krb_cn_privacy_encode_pkt (assoc_sec, sec,
			iov, iovlen, out_iov);
		    if (out_iov->base == NULL){
			*st = rpc_s_no_memory;
			return;
		    }
	            break;
		}
#endif /* NOENCRYPTION */
                default:
                {
                    *st = rpc_s_unsupported_authn_level;
                    return;
                }
            }
            break;
        }

        case RPC_C_CN_PKT_BIND:
        case RPC_C_CN_PKT_ALTER_CONTEXT:
        case RPC_C_CN_PKT_BIND_ACK:
        case RPC_C_CN_PKT_ALTER_CONTEXT_RESP:
        case RPC_C_CN_PKT_AUTH3:
        {
            switch ((int)authn_level)
            {
                case rpc_c_authn_level_none:
                    /* checksum assumed to be zero already */
                    break;
                case rpc_c_authn_level_pkt_integrity:
#ifndef NOENCRYPTION
                case rpc_c_authn_level_pkt_privacy:
#endif
                    bind_auth_value = (rpc_cn_bind_auth_value_priv_p_t) 
                        (auth_tlr->auth_value);
                    bind_auth_value->checksum_length = 
                        krb_cn_info->auth_cksm_len;
            
                    /*
                     * checksum = des_checksum (IV, K, msg,
                     *            sizeof (msg) - sizeof (checksum) -
                     *            sizeof (cred)
                     */
                    msg_size = ((rpc_cn_common_hdr_t *)(iov[0].base))
                                ->frag_len - 
                               krb_cn_info->auth_cksm_len -
                               bind_auth_value->cred_length;

                    rpc__krb_cn_coalesce_fragbufs (iov, iovlen, out_iov);
		    if (out_iov->base == NULL){
			*st = rpc_s_no_memory;
			return;
		    }
                    auth_tlr = RPC_CN_PKT_AUTH_TLR (
                               (rpc_cn_packet_t *) out_iov->base, 
                               out_iov->len);
                    bind_auth_value = (rpc_cn_bind_auth_value_priv_p_t) 
                         (auth_tlr->auth_value);
                    byte_ptr = bind_auth_value->credentials;
                    byte_ptr += bind_auth_value->cred_length;
                    checksum_ptr = (sec_des_block *) byte_ptr;

                    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
                    {
                        rpc__krb_cn_compute_ivec (assoc_sec, 
                            RPC_CN_TRANSMIT,
                            (boolean32) sec->sec_info->is_server,
                            &ivec);
                        sec_des_cbc_cksum (
                            (sec_des_block *) out_iov->base, 
                            checksum_ptr,
                            msg_size,
                            krb_cn_info->key_sched, 
                            &ivec);
                    }
                    else
                    {
                        rpc__krb_cn_compute_md5_cksm ((byte_p_t) out_iov->base, 
                                              msg_size, 
                                              &(krb_cn_info->encrypted_crc),
                                              assoc_sec, 
                                              RPC_CN_TRANSMIT,
                                              sec->sec_info->is_server,
                                              (idl_byte*) checksum_ptr);
                    }
                    break;

                case rpc_c_authn_level_connect:
                case rpc_c_authn_level_call:
                case rpc_c_authn_level_pkt:
                    bind_auth_value = (rpc_cn_bind_auth_value_priv_p_t) 
                        (auth_tlr->auth_value);
                    bind_auth_value->checksum_length = 
                        krb_cn_info->auth_cksm_len;
                    /*
                     * checksum = des_checksum (IV, K, 0, 8)
                     */
                    byte_ptr = bind_auth_value->credentials;
                    byte_ptr += bind_auth_value->cred_length;
                    checksum_ptr = (sec_des_block *) byte_ptr;

                    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
                    {
                        rpc__krb_cn_compute_ivec (assoc_sec, 
                            RPC_CN_TRANSMIT,
                            (boolean32) sec->sec_info->is_server,
                            &ivec);
                        sec_des_cbc_cksum (&zero_block, 
                            checksum_ptr,
                            sizeof(zero_block),     /* better be 8 */
                            krb_cn_info->key_sched, 
                            &ivec);
                    }
                    else
                    {
                        rpc__krb_cn_compute_md5_cksm ((byte_p_t) md_zero_block,
                                              sizeof(md_zero_block), 
                                              &(krb_cn_info->encrypted_crc),
                                              assoc_sec, 
                                              RPC_CN_TRANSMIT,
                                              sec->sec_info->is_server,
                                              (idl_byte*) checksum_ptr);
                    }
                    
                    break;
                default:
                {
                    *st = rpc_s_unsupported_authn_level;
                    return;
                }
            }
        }

        case RPC_C_CN_PKT_BIND_NAK:
            /*
             * These have no trailers.
             */
            break;

        default:
        {
	    /*
	     * rpc_m_bad_pkt_type
	     * "(%s) Illegal or unknown packet type: %x"
	     */
	    RPC_DCE_SVC_PRINTF ((
		DCE_SVC(RPC__SVC_HANDLE, "%s%x"),
		rpc_svc_auth,
		svc_c_sev_fatal | svc_c_action_abort,
		rpc_m_bad_pkt_type,
		"rpc__krb_cn_pre_send",
		(int)ptype ));
            break;
        }
    }

    *st = rpc_s_ok;
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_recv_check
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will perform per-packet security
**      processing on a packet after it is received. This
**      includes decryption and verification of checksums.
**      Note that the inputs cred_len and auth_tlr are provided
**      by the caller to minimize the computation within this routine
**      for endian differences.
**
**      The algorithms for determining the checksums for the
**      various auth levels are described in the "Network
**      Computing Architecture Remote Procedure Call RunTime
**      Extensions Specification" aka "the architecture spec."
**
**  INPUTS:
**
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      pdu             A pointer to the PDU received.
**      pdu_len         The length, in bytes, of the PDU.
**      cred_len        The length, in bytes, of the credentials.
**      auth_tlr        A pointer to the auth trailer.
**      unpack_ints     A boolean indicating whether the integer rep
**                      of fields in the pdu need to be adjusted for
**                      endian differences.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_recv_check 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    rpc_cn_common_hdr_p_t           pdu,
    unsigned32                      pdu_len,
    unsigned32                      cred_len,
    rpc_cn_auth_tlr_p_t             auth_tlr,
    boolean32                       unpack_ints,
    unsigned32                      *st
)
{
    rpc_cn_auth_value_priv_t    *auth_value;
    rpc_cn_bind_auth_value_priv_p_t bind_auth_value;
    unsigned32                  ptype;
    unsigned32                  authn_level;
    unsigned32                  assoc_uuid_crc;
    sec_des_block               ivec;
    sec_des_block               local_checksum;
    sec_des_block               *checksum_ptr;
    idl_byte                    local_md_checksum[RPC_C_CN_DCE_MD5_CKSM_LEN];
    unsigned32                  msg_size;
    unsigned8                   *byte_ptr;
    rpc_krb_cn_info_t           *krb_cn_info;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_recv_check)\n"));

    ptype = pdu->ptype;
    krb_cn_info = (rpc_krb_cn_info_p_t)sec->sec_cn_info;
    auth_value = (rpc_cn_auth_value_priv_t *)(auth_tlr->auth_value);
    authn_level = auth_tlr->auth_level;
    assoc_uuid_crc = assoc_sec->assoc_uuid_crc;

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_GENERAL,
                    ("(rpc__krb_cn_recv_check) authn level->%x packet type->%x\n", authn_level, ptype));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_recv_check) prot->%x level->%x key_id->%x assoc_uuid_crc->%x xmit_seq->%x recv_seq->%x ptype->%x\n",
                    rpc_c_authn_dce_private,
                    authn_level,
                    sec->sec_key_id,
                    assoc_uuid_crc,
                    assoc_sec->assoc_next_snd_seq,
                    assoc_sec->assoc_next_rcv_seq,
                    ptype));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_RECV_CHECK))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif


    switch ((int)ptype)
    {
        case RPC_C_CN_PKT_REQUEST:
        case RPC_C_CN_PKT_RESPONSE:
        case RPC_C_CN_PKT_FAULT:
        case RPC_C_CN_PKT_SHUTDOWN:
        case RPC_C_CN_PKT_REMOTE_ALERT:
        case RPC_C_CN_PKT_ORPHANED:
        {
	    switch ((int)authn_level)
	    {
		case rpc_c_authn_level_none:
		case rpc_c_authn_level_connect:
		    /*
		     * Do nothing in this case.
		     * The key_id & sub_type fields have been
		     * filled in by pre_call.
		     */
		    break;

		case rpc_c_authn_level_call:
		case rpc_c_authn_level_pkt:
                    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
		    {
		        rpc__krb_cn_compute_ivec (assoc_sec, 
                            RPC_CN_RECEIVE,
			    /* 
			     * If we are the server, the one which
			     * sent the PDU must have been the client.
			     */
			    ! (sec->sec_info->is_server),
			    &ivec);
                        sec_des_cbc_cksum (&zero_block, 
			    &local_checksum,
			    sizeof(zero_block), /* better be 8 */
			    krb_cn_info->key_sched, 
			    &ivec);
		        if (! rpc__krb_cn_des_cksum_eq (
			   (sec_des_block *)auth_value->checksum,
			   &local_checksum))
		        {
			    *st = rpc_s_invalid_checksum;
			    return;
		        }
                    }
                    else
                    {
                        rpc__krb_cn_compute_md5_cksm ((byte_p_t) md_zero_block,
                                                sizeof(md_zero_block),
                                                &(krb_cn_info->encrypted_crc),
                                                assoc_sec,
                                                RPC_CN_RECEIVE,
                                                !(sec->sec_info->is_server),
                                                local_md_checksum);
		        if (! rpc__krb_cn_md_cksum_eq (
			   (idl_byte *)(auth_value->checksum),
			   local_md_checksum))
		        {
			    *st = rpc_s_invalid_checksum;
			    return;
		        }
                    }


		    break;

		case rpc_c_authn_level_pkt_integrity:
		    /*
		     * Compute checksum over the entire message,
		     * excluding the checksum field itself.
		     */
		    msg_size = pdu_len - krb_cn_info->auth_cksm_len;

                    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
                    {
		        rpc__krb_cn_compute_ivec (assoc_sec, 
                            RPC_CN_RECEIVE,
			    /* 
			     * If we are the server, the one which
			     * sent the PDU must have been the client.
			     */
			    ! (sec->sec_info->is_server),
			    &ivec);
                        sec_des_cbc_cksum (
                            (sec_des_block *) pdu, 
			    &local_checksum,
			    msg_size,
			    krb_cn_info->key_sched, 
			    &ivec);
		        if (! rpc__krb_cn_des_cksum_eq (
			      (sec_des_block *) (auth_value->checksum),
			      &local_checksum))
		        {
			    *st = rpc_s_invalid_checksum;
			    return;
		        }
                    }
                    else
                    {
                        rpc__krb_cn_compute_md5_cksm ((byte_p_t)pdu,
                                                msg_size,
                                                &(krb_cn_info->encrypted_crc),
                                                assoc_sec, 
                                                RPC_CN_RECEIVE,
                                                !(sec->sec_info->is_server),
                                                local_md_checksum);

		        if (! rpc__krb_cn_md_cksum_eq (
			      (idl_byte *)(auth_value->checksum),
			      local_md_checksum))
		        {
RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_recv_check failed)\n"));
			    *st = rpc_s_invalid_checksum;
			    return;
		        }
else
RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_recv_check succeeded)\n"));
                    }

		    break;
#ifndef NOENCRYPTION
		case rpc_c_authn_level_pkt_privacy:
		    rpc__krb_cn_privacy_decode_pkt (
		        assoc_sec, sec, (rpc_cn_packet_p_t)pdu, 
			pdu_len, auth_tlr, unpack_ints, st);
		    if (*st != rpc_s_ok)
		    {
		        return;
		    }
		    break;
#endif
		default:
		{
		    *st = rpc_s_unsupported_authn_level;
		    return;
		}
	    }

            break;
        }

        case RPC_C_CN_PKT_BIND:
        case RPC_C_CN_PKT_BIND_ACK:
        case RPC_C_CN_PKT_BIND_NAK:
        case RPC_C_CN_PKT_ALTER_CONTEXT:
        case RPC_C_CN_PKT_ALTER_CONTEXT_RESP:
        case RPC_C_CN_PKT_AUTH3:
	{
            /*
             * Save the sub_type and checksum_length passed in the
             * packet if this is a bind or alter_context pdu and the
             * authn level is greater than level_none.  Also check at
             * this point if the values make sense; if they don't then
             * return with an error.
             * Note:  if an implementation wishes to not support either
             * of the checksum algorithms, the following logic needs to
             * be modified so that a different error is returned.
             */
            if (((ptype == RPC_C_CN_PKT_BIND) ||
                 (ptype == RPC_C_CN_PKT_ALTER_CONTEXT))        &&
                (authn_level != rpc_c_authn_level_none))
            {
                bind_auth_value = (rpc_cn_bind_auth_value_priv_p_t)
                    (auth_tlr->auth_value);
                krb_cn_info->auth_subtype = bind_auth_value->sub_type;
                krb_cn_info->auth_cksm_len = bind_auth_value->checksum_length;
                if (((krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE_MD5) &&
                     (krb_cn_info->auth_cksm_len == RPC_C_CN_DCE_MD5_CKSM_LEN))   ||
                    ((krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE) &&
                     (krb_cn_info->auth_cksm_len == RPC_C_CN_DCE_CKSM_LEN)))
                {
                    /* Valid cases, so no problem */
                    ;
                }
                else
                {
                    *st = rpc_s_invalid_checksum;
                    return;
                }
            }

	    switch ((int)authn_level)
	    {
		case rpc_c_authn_level_none:
		{
                    /* Assume it's zero as it should be. */
		    break;
		}
		case rpc_c_authn_level_connect:
		case rpc_c_authn_level_call:
		case rpc_c_authn_level_pkt:
		{
		    bind_auth_value = (rpc_cn_bind_auth_value_priv_p_t) 
			(auth_tlr->auth_value);
		    byte_ptr = bind_auth_value->credentials;
		    byte_ptr += cred_len;
		    checksum_ptr = (sec_des_block *) byte_ptr;

                    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
		    {
		        rpc__krb_cn_compute_ivec (assoc_sec, 
                            RPC_CN_RECEIVE,
			    ! ((boolean32) sec->sec_info->is_server),
			    &ivec);
                        sec_des_cbc_cksum (&zero_block, 
			    &local_checksum,
			    sizeof(zero_block),	/* better be 8 */
			    krb_cn_info->key_sched, 
			    &ivec);
		        if (! rpc__krb_cn_des_cksum_eq (checksum_ptr, 
                                                        &local_checksum))
		        {
			    *st = rpc_s_invalid_checksum;
			    return;
		        }
                    }
                    else
                    {
                        rpc__krb_cn_compute_md5_cksm ((byte_p_t)md_zero_block,
                                                sizeof(md_zero_block), 
                                                &(krb_cn_info->encrypted_crc),
                                                assoc_sec,
                                                RPC_CN_RECEIVE,
                                                !(sec->sec_info->is_server),
                                                local_md_checksum);
		        if (! rpc__krb_cn_md_cksum_eq (
                            (idl_byte *)(checksum_ptr), 
                            local_md_checksum))
		        {
			    *st = rpc_s_invalid_checksum;
			    return;
		        }
                    }
		    break;
		}
		case rpc_c_authn_level_pkt_integrity:
#ifndef NOENCRYPTION
		case rpc_c_authn_level_pkt_privacy:
#endif
		{
		    bind_auth_value = (rpc_cn_bind_auth_value_priv_p_t) 
			(auth_tlr->auth_value);
                    msg_size = pdu_len -
                               krb_cn_info->auth_cksm_len -
			       cred_len;
		    byte_ptr = bind_auth_value->credentials;
		    byte_ptr += cred_len;
		    checksum_ptr = (sec_des_block *) byte_ptr;

                    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
		    {
		        rpc__krb_cn_compute_ivec (assoc_sec, 
                            RPC_CN_RECEIVE,
			    ! ((boolean32) sec->sec_info->is_server),
			    &ivec);
                        sec_des_cbc_cksum (
                            (sec_des_block *) pdu, 
			    &local_checksum,
			    msg_size,
			    krb_cn_info->key_sched, 
			    &ivec);
		        if (! rpc__krb_cn_des_cksum_eq (checksum_ptr, 
                                                        &local_checksum))
		        {
			    *st = rpc_s_invalid_checksum;
			    return;
		        }
                    }
                    else
                    {
                        rpc__krb_cn_compute_md5_cksm ((byte_p_t)pdu,
                                                msg_size,
                                                &(krb_cn_info->encrypted_crc),
                                                assoc_sec, 
                                                RPC_CN_RECEIVE,
                                                !(sec->sec_info->is_server),
                                                local_md_checksum);
		        if (! rpc__krb_cn_md_cksum_eq (
                            (idl_byte *)(checksum_ptr),
                            local_md_checksum))
		        {
			    *st = rpc_s_invalid_checksum;
			    return;
		        }
                    }
		    
		    break;
		}
		default:
		{
		    *st = rpc_s_unsupported_authn_level;
		    return;
		}
	    }
	    break;
	}

        default:
        {
	    /*
	     * rpc_m_bad_pkt_type
	     * "(%s) Illegal or unknown packet type: %x"
	     */
	    RPC_DCE_SVC_PRINTF ((
		DCE_SVC(RPC__SVC_HANDLE, "%s%x"),
		rpc_svc_auth,
		svc_c_sev_fatal | svc_c_action_abort,
		rpc_m_bad_pkt_type,
		"rpc__krb_cn_recv_check",
		(int)ptype ));
            break;
        }
    }

    *st = rpc_s_ok;
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_tlr_uuid_crc
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will locate and return the association
**      UUID CRC contained in the auth_value field of an
**      authentication trailer of an rpc_bind, rpc_bind_ack,
**      rpc_alter_context or rpc_alter_context_response PDU.
**
**  INPUTS:
**
**      auth_value      A pointer to the auth_value field in an authentication
**                      trailer.
**      auth_value_len  The length, in bytes, of the auth_value field.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      assoc_uuid_crc  The association UUID CRC contained in the auth_value
**                      field.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_tlr_uuid_crc 
(
    pointer_t               auth_value,
    unsigned32              auth_value_len,
    unsigned32              *uuid_crc
)
{
    rpc_cn_bind_auth_value_priv_t       *priv_auth_value;

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_tlr_uuid_crc)\n"));

    assert (auth_value_len >= RPC_CN_PKT_SIZEOF_BIND_AUTH_VAL);
    priv_auth_value = (rpc_cn_bind_auth_value_priv_t *)auth_value;
    *uuid_crc = priv_auth_value->assoc_uuid_crc;

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_GENERAL,
                    ("(rpc__krb_cn_tlr_uuid_crc) assoc_uuid_crc->%x\n", *uuid_crc));
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_tlr_unpack
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will byte swap all the appropriate fields
**      of the the auth_value field of an authentication
**      trailer. Note that nothing in the credentials field needs to
**      be processed.  Note that this routine does not determine whether
**      byte fields need to be swapped - that is the caller's responsibility.
**
**      This routine is called as part of unpacking the packet when
**      it is processed by the receiver thread.  This routine does not
**      check for invalid packet types as that is already handled earlier
**      in the receiver thread.
**
**
**  INPUTS:
**
**      auth_value_len  The length, in bytes, of the auth_value field.
**      packed_drep     The packed Network Data Representation, (see NCA RPC
**                      RunTime Extensions Specification Version OSF TX1.0.9
**                      pre 1003 for details), of the remote machine.
**
**  INPUTS/OUTPUTS:
**
**      pkt_p           A pointer to the entire packet.
**
**  OUTPUTS:            none
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_tlr_unpack 
(
    rpc_cn_packet_p_t       pkt_p,
    unsigned32              auth_value_len,
    unsigned8               *packed_drep
)
{

    rpc_cn_auth_tlr_p_t               authp;
    rpc_cn_bind_auth_value_priv_p_t   auth_value_ptr;
    unsigned8                         *authz_ptr;
    char                              *name_ptr;

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_tlr_unpack)\n"));

    /*
     * Find the start of the authentication trailer.  Note that we
     * don't have to worry about endian problems here, because the
     * header has already been unpacked.
     */
    authp = RPC_CN_PKT_AUTH_TLR (pkt_p, RPC_CN_PKT_FRAG_LEN (pkt_p));

    /*
     * Swap the key_id field in the common part of the auth trailer.
     */
    SWAB_INPLACE_32 (authp->key_id);

    /*
     * The format of the auth_value field in the auth trailer depends on
     * the PDU type.  There is only work to do if the type is bind, 
     * alter_context, bind_ack, alter_context_resp, or auth3.
     */
    switch (RPC_CN_PKT_PTYPE (pkt_p))
    {
        /*
         * Cases where there is work to do.
         */
        case RPC_C_CN_PKT_BIND:
        case RPC_C_CN_PKT_ALTER_CONTEXT:
        case RPC_C_CN_PKT_BIND_ACK:
        case RPC_C_CN_PKT_ALTER_CONTEXT_RESP:
        case RPC_C_CN_PKT_AUTH3:
            /*
             * Swap the assoc_uuid_crc and cred_length fields.
             */
            auth_value_ptr = 
                (rpc_cn_bind_auth_value_priv_p_t) &(authp->auth_value[0]);
            SWAB_INPLACE_32 (auth_value_ptr->assoc_uuid_crc);
            SWAB_INPLACE_16 (auth_value_ptr->cred_length);
            break;

        /*
         * Uninteresting cases.
         */
	default:
            break;

    }

    /*
     * Handle the special case where the principal name is in the 
     * credentials and we have to convert between ascii and ebcdic.
     */
    
    if ((((RPC_CN_PKT_PTYPE (pkt_p)) == RPC_C_CN_PKT_BIND) ||
         ((RPC_CN_PKT_PTYPE (pkt_p)) == RPC_C_CN_PKT_ALTER_CONTEXT)) &&
        (authp->auth_level == rpc_c_authn_level_none))
    {
        auth_value_ptr = 
            (rpc_cn_bind_auth_value_priv_p_t) &(authp->auth_value[0]);
        authz_ptr = (unsigned8 *) (auth_value_ptr->credentials);
        name_ptr = (char *) ((auth_value_ptr->credentials) + 
            sizeof (unsigned8));
        if ((*authz_ptr == rpc_c_authz_name) &&
            (NDR_LOCAL_CHAR_REP != NDR_DREP_CHAR_REP (packed_drep)))
        {
	    rpc_util_strcvt (NDR_LOCAL_CHAR_REP == ndr_c_char_ascii,
			     strlen(name_ptr), 
                             (unsigned char *) name_ptr, 
                             (unsigned char *) name_ptr);
        }
    }
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_vfy_client_req
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will decode the auth_value field of
**      either an rpc_bind or rpc_alter_context PDU. Any
**      error encountered while authenticating the client
**      will result in an error status return. The contents
**      of the credentials field includes the authorization
**      data. This is called from the server side association
**      state machine. Note that upon successful return
**      the auth information rep will contain the client's
**      authorization protocol and data.
**
**      For Kerberos, this means verifying an KRB_AP_REQ message
**      contained in the credentials field of the auth_value.
**
**  INPUTS:
**
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      auth_value      A pointer to the auth_value field in the rpc_bind or
**                      rpc_alter_context PDU authentication trailer.
**      auth_value_len  The length, in bytes, of auth_value.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine. 
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_vfy_client_req 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    pointer_t                       auth_value,
    unsigned32                      auth_value_len,
    unsigned32			    old_client,	
    unsigned32                      *st
)
{
    rpc_cn_bind_auth_value_priv_t       *priv_auth_value;
    sec_krb_message                     krb_ap_req;
    unsigned32                          expiration;
    rpc_krb_info_t                      *krb_info;
    rpc_krb_cn_info_t                   *krb_cn_info;
    sec_des_key                         key;
    unsigned32                          assoc_uuid_crc_little_endian;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_vfy_client_req)\n"));

    priv_auth_value = (rpc_cn_bind_auth_value_priv_t *)auth_value;
    
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_vfy_client_req) prot->%x level->%x key_id->%x assoc_uuid_crc->%x xmit_seq->%x recv_seq->%x\n",
                    rpc_c_authn_dce_private,
                    sec->sec_info->authn_level,
                    sec->sec_key_id,
                    assoc_sec->assoc_uuid_crc,
                    assoc_sec->assoc_next_snd_seq,
                    assoc_sec->assoc_next_rcv_seq));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_VFY_CLIENT_REQ))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif

    /*
     * The KRB_AP_REQ message is the credentials field of the auth
     * value. Get the length and a pointer to it and decode it. This
     * will result in the client name and pac, server name and
     * authn level, authz protocol, credentials
     * expiration time and the ticket being produced.
     */
    krb_info = (rpc_krb_info_t *)sec->sec_info;
    krb_cn_info = (rpc_krb_cn_info_t *)sec->sec_cn_info;
    krb_ap_req.length = priv_auth_value->cred_length;
    krb_ap_req.data = priv_auth_value->credentials;
    *st = sec_krb_cn_decode_message (&krb_ap_req, 
				     old_client?SEC_AUTHZ_FMT_V1_0:
				     SEC_AUTHZ_FMT_V1_1,
                                     &krb_info->client_name,
                                     &krb_info->client_pac,
				     &krb_info->client_creds,  /* FAKE-EPAC */
                                     &krb_info->server, 
                                     &krb_info->auth_info.authz_protocol,
                                     &key,
                                     &expiration, 
                                     &krb_cn_info->u.server.ctime,
                                     &krb_cn_info->u.server.cusec);

    if (*st == rpc_s_ok)
    {
        /*
         * Any authentication level except none will include a
         * KRB_AP_REQ in the credentials field. From this the
         * session key was extracted.
         */
        if (krb_info->auth_info.authn_level != rpc_c_authn_level_none)
        {
            /*
             * Add the session key to the security context, and
             * compute the key_sched and the 
             * encrypted crc (if using md5).  These will be used by 
             * "pre_send" and "recv_check" when computing checksums.
             */
            krb_info->creds_valid = true;
            krb_cn_info->key = key;
            *st = sec_des_key_sched (&krb_cn_info->key, krb_cn_info->key_sched);
            krb_cn_info->auth_subtype = priv_auth_value->sub_type;
            if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE_MD5)
            {
                assoc_uuid_crc_little_endian = assoc_sec->assoc_uuid_crc;
                if (NDR_LOCAL_INT_REP != ndr_c_int_little_endian)
                {
                    SWAB_INPLACE_32 (assoc_uuid_crc_little_endian);
                }
                sec_des_cbc_cksum (
		    (sec_des_block *)&assoc_uuid_crc_little_endian, 
                    &krb_cn_info->encrypted_crc,
                    sizeof(assoc_sec->assoc_uuid_crc),
                    krb_cn_info->key_sched, 
                    &zero_block);   /* ivec = 0 */
                krb_cn_info->encrypted_crc_valid = true;
            }
        }

        /*
         * Stash the client principal name or client PAC, depending
         * on the authorization service chosen in the auth info.
         */
        switch ((int)krb_info->auth_info.authz_protocol) 
        {
            case rpc_c_authz_name:
            {
                krb_info->auth_info.u.s.privs = 
                    (rpc_authz_handle_t) krb_info->client_name;		

		{ /* FAKE-EPAC */
		    krb_info->auth_info.u.s.creds = &krb_info->client_creds;
		}

                break;
            }

            case rpc_c_authz_dce:
            {
                krb_info->auth_info.u.s.privs = 
                    (rpc_authz_handle_t) &krb_info->client_pac;
		
		{ /* FAKE-EPAC */
		    krb_info->auth_info.u.s.creds = &krb_info->client_creds;
		}
                break;
            }
        }
        
        if ((krb_info->auth_info.server_princ_name == NULL)
            && (krb_info->server != NULL))
        {
            *st = sec_krb_unparse_name (krb_info->server, 
                                         (unsigned char **)&krb_info->auth_info.server_princ_name);
            RPC_DBG_GPRINTF(("server name is %s\n", krb_info->auth_info.server_princ_name));
        }
        krb_info->client_valid = 1;
    }
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_vfy_srvr_resp
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will decode auth_value field either an
**      rpc_bind_ack or rpc_alter_context_response PDU. If the
**      credentials field of the auth_value field contains an
**      authentication protocol specific encoding of an error
**      this will be returned as an error status code. This is
**      called from the client side association state machine.
**      Note that upon successful return the auth information
**      rep will contain the client's authorization protocol
**      and data.
**
**      For Kerberos, this means verifying a KRB_AP_REP or KRB_ERROR message
**      contained in the credentials field of the auth_value.
**
**  INPUTS:
**
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      auth_value      A pointer to the auth_value field in the rpc_bind or
**                      rpc_alter_context PDU authentication trailer.
**      auth_value_len  The length, in bytes, of auth_value.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_vfy_srvr_resp 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    pointer_t                       auth_value,
    unsigned32                      auth_value_len,
    unsigned32                      *st
)
{
    rpc_cn_bind_auth_value_priv_t       *priv_auth_value;
    sec_krb_message                     krb_message;
    rpc_krb_info_t                      *krb_info;
    rpc_krb_cn_info_t                   *krb_cn_info;

    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_vfy_srvr_resp)\n"));

    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_PKT,
                    ("(rpc__krb_cn_vfy_server_resp) prot->%x level->%x key_id->%x assoc_uuid_crc->%x xmit_seq->%x recv_seq->%x\n",
                    rpc_c_authn_dce_private,
                    sec->sec_info->authn_level,
                    sec->sec_key_id,
                    assoc_sec->assoc_uuid_crc,
                    assoc_sec->assoc_next_snd_seq,
                    assoc_sec->assoc_next_rcv_seq));

#ifdef DEBUG
    if (RPC_DBG_EXACT(rpc_es_dbg_cn_errors,
                      RPC_C_CN_DBG_AUTH_VFY_SERVER_RESP))
    {
        *st = RPC_S_CN_DBG_AUTH_FAILURE;
        return;
    }
#endif

    /*
     * The KRB_AP_REP or KRB_ERROR message is the credentials field of the auth
     * value. Get the length and a pointer to it and decode it. Note
     * that the first key in the "keys" array is the multi-session key.
     */
    krb_info = (rpc_krb_info_t *)sec->sec_info;
    krb_cn_info = (rpc_krb_cn_info_t *)sec->sec_cn_info;
    priv_auth_value = (rpc_cn_bind_auth_value_priv_t *)auth_value;
    krb_message.length = priv_auth_value->cred_length;
    krb_message.data = priv_auth_value->credentials;
    *st = sec_krb_cn_decode_rep_message (krb_info->auth_info.authn_level,
                                         &krb_message,
					 krb_cn_info->u.client.ctime,
					 krb_cn_info->u.client.cusec,
                                         &(krb_cn_info->key));
}



/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_init
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Perform Kerberos/CN specific initialization and return a
**      pointer to the Kerberos/CN specific entry points.
**
**  INPUTS:             none
**
**  INPUTS/OUTPUTS:     
**
**  OUTPUTS:            
**
**      epv             A pointer to the Kerberos/CN specific entry point/
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

PRIVATE rpc_protocol_id_t       rpc__krb_cn_init 
(
    rpc_auth_rpc_prot_epv_p_t       *epv,
    unsigned32                      *st
)
{
    CODING_ERROR (st);
    RPC_DBG_PRINTF (rpc_e_dbg_auth, RPC_C_CN_DBG_AUTH_ROUTINE_TRACE,
                    ("(rpc__krb_cn_init)\n"));

    *epv = (rpc_auth_rpc_prot_epv_p_t) (&rpc_g_krb_cn_epv);
    rpc__krb_cn_inq_cksum_algorithm (st);
    return (RPC_C_PROTOCOL_ID_NCACN);
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_coalesce_fragbufs
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Copy all the elements of an iov into a contiguous
**      buffer.  This buffer is allocated from heap.
**
**  INPUTS:
**
**      iov             iov describing the input data.
**      iovlen          number of elements in the iov.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      out_iov         iov (of length one) describing the
**                      contiguous buffer.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_coalesce_fragbufs 
(
    rpc_socket_iovec_p_t            iov,
    unsigned32                      iovlen,
    rpc_socket_iovec_p_t            out_iov
)
{
    rpc_socket_iovec_p_t	cur_iov;
    unsigned32			i;
    unsigned8                   *p;

    RPC_MEM_ALLOC (out_iov->base, unsigned8 *, 
		   RPC_C_CN_LARGE_FRAG_SIZE,
		   RPC_C_MEM_CN_ENCRYPT_BUF,
		   RPC_C_MEM_WAITOK);
    if (out_iov->base == NULL)
	return;
    out_iov->len = 0;

    for (i=0, cur_iov=iov, p=out_iov->base; i<iovlen; i++, cur_iov++)
    {
	if (cur_iov->len >= 0)
	{
	    memcpy (p, cur_iov->base, cur_iov->len);
	    out_iov->len += cur_iov->len;
	    p += cur_iov->len;
	}
    }
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_compute_ivec
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Computes the DES initialization vector used for checksum
**      computations.
**
**  INPUTS:
**
**      assoc_sec       A pointer to the per-association security context
**                      including the association UUID CRC and sequence
**                      numbers.
**      is_transmitter  Indicates whether the caller is the transmitter or
**                      the receiver.  Pre_send calls as the transmitter
**                      and recv_check calls as the receiver.
**      is_server       Indicates whether the caller is the server or
**                      the client.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      ivec            DES initialization vector.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/
INTERNAL void rpc__krb_cn_compute_ivec 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    boolean32                       is_transmitter,
    boolean32                       is_server,
    sec_des_block                   *ivec
)
{
    unsigned32                  crc_assoc_uuid;
    unsigned32                  sequence_number;
    unsigned32                  *p;

    crc_assoc_uuid = assoc_sec->assoc_uuid_crc;
    if (is_transmitter)
    {
        sequence_number = assoc_sec->assoc_next_snd_seq;
    }
    else
    {
        sequence_number = assoc_sec->assoc_next_rcv_seq;
    }

    /*
     * Flip the msb of the 32 sequence number if the message
     * is from the server to the client.
     */
    if (is_server)
    {
	sequence_number ^= 0x80000000U;
    }

    if (NDR_LOCAL_INT_REP != ndr_c_int_little_endian)
    {
	SWAB_INPLACE_32 (crc_assoc_uuid);
	SWAB_INPLACE_32 (sequence_number);
    }

    /*
     * Lowest addressed 4 octets of IV is crc_assoc_uuid in
     * little-endian order.
     * The highest 4 octets are taken from the sequence
     * number (with msb inverted as needed).
     */
    p = (unsigned32 *) ivec;
    *p = crc_assoc_uuid;
    *++p = sequence_number;

}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_des_cksum_eq
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Determines whether two DES checksums are equal.
**      computations.
**
**  INPUTS:
**
**      checksum1       A DES checksum.
**      checksum2       A DES checksum.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     true if the 2 checksums are equal.
**
**  SIDE EFFECTS:       none
**
**--
**/
INTERNAL boolean32 rpc__krb_cn_des_cksum_eq 
(
    sec_des_block *checksum1,
    sec_des_block *checksum2
)
{
    boolean32  cksum_eq;
    idl_byte   *p1, *p2;
    unsigned32 i;

    cksum_eq = true;
    p1 = checksum1->bits;
    p2 = checksum2->bits;

    for (i=0; i<RPC_C_CN_DCE_CKSM_LEN; i++)
    {
	if (*p1++ != *p2++)
	{
	    cksum_eq = false;
	    break;
	}
    }
    return (cksum_eq);
}

/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_md_cksum_eq
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      Determines whether two DES checksums are equal.
**      computations.
**
**  INPUTS:
**
**      checksum1       A md checksum.
**      checksum2       A md checksum.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     true if the 2 checksums are equal.
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL boolean32 rpc__krb_cn_md_cksum_eq 
(
    idl_byte      *checksum1,
    idl_byte      *checksum2
)
{
    boolean32  cksum_eq;
    unsigned32 i;

    cksum_eq = true;

    for (i=0; i<RPC_C_CN_DCE_MD5_CKSM_LEN; i++)
    {
	if (*checksum1++ != *checksum2++)
	{
	    cksum_eq = false;
	    break;
	}
    }
    return (cksum_eq);
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_privacy_encode_pkt
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will perform per-packet privacy and
**      strong integrity processing on a packet before it is sent. 
**      This includes checksumming and encryption.
**
**      Note that the data is copied to a contiguous buffer for 
**      checksumming and encryption.
**
**  INPUTS:
**
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      iov             A pointer to the iovector containing the PDU
**                      about to be sent. The appropriate per-packet security
**                      services will be applied to it. 
**      iovlen          The length of the iov.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      out_iov         An iovector element.  This iovector element
**                      will describe packet after it has been
**                      encrypted.
**                      The caller should free out_iov->base.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_privacy_encode_pkt 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    rpc_socket_iovec_p_t            iov,
    unsigned32                      iovlen,
    rpc_socket_iovec_p_t            out_iov
)
{
    rpc_cn_packet_p_t	       pkt;
    unsigned32                 ptype;
    unsigned32		       hdr_len, trailer_len, stub_length, pad_length;
    unsigned32                 frag_len, auth_len;
    unsigned32		       i, *int_ptr;
    unsigned8		       *stub, *byte_ptr;
    sec_des_block	       checksum_temp, ivec;
    idl_byte                   checksum_md_temp[RPC_C_CN_DCE_MD5_CKSM_LEN];
    rpc_cn_auth_tlr_p_t        auth_tlr;
    rpc_cn_auth_value_priv_p_t auth_value;
    rpc_krb_cn_info_t          *krb_cn_info;

    pkt = (rpc_cn_packet_p_t)iov[0].base;
    krb_cn_info = (rpc_krb_cn_info_p_t)sec->sec_cn_info;

    /*
     * Figure out the size of the header.
     */
    ptype = RPC_CN_PKT_PTYPE(pkt);
    switch ((int)ptype)
    {
	case RPC_C_CN_PKT_REQUEST:
	    hdr_len = RPC_CN_PKT_SIZEOF_RQST_HDR_NO_OBJ;
	    if (RPC_CN_PKT_OBJ_UUID_PRESENT(pkt))
	    {
		hdr_len = RPC_CN_PKT_SIZEOF_RQST_HDR_W_OBJ;
	    }
	    break;

	case RPC_C_CN_PKT_RESPONSE:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_RESP_HDR;
	    break;
	}
	case RPC_C_CN_PKT_FAULT:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_FAULT_HDR;
	    break;
	}
        case RPC_C_CN_PKT_SHUTDOWN:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_SHUTDOWN_HDR;
	    break;
	}
        case RPC_C_CN_PKT_REMOTE_ALERT:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_ALERT_HDR;
	    break;
	}
        case RPC_C_CN_PKT_ORPHANED:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_ORPHANED_HDR;
	    break;
	}
	default:
	{
	    /*
	     * rpc_m_bad_pkt_type
	     * "(%s) Illegal or unknown packet type: %x"
	     */
	    RPC_DCE_SVC_PRINTF ((
		DCE_SVC(RPC__SVC_HANDLE, "%s%x"),
		rpc_svc_auth,
		svc_c_sev_fatal | svc_c_action_abort,
		rpc_m_bad_pkt_type,
		"rpc__krb_cn_privacy_encode_pkt",
		(int)ptype ));
	    break;
	}
    }

    /*
     * Compute the frag_len and auth_len to remove the extra
     * padding we allocated in pre_call.
     */
    frag_len = RPC_CN_PKT_FRAG_LEN (pkt) - RPC_CN_PRIVACY_PAD_LEN;
    auth_len = RPC_CN_PKT_AUTH_LEN (pkt) - RPC_CN_PRIVACY_PAD_LEN;

    /*
     * If there is a stub body, compute how much padding we need 
     * to bring the stub data to a 3 mod 8 boundary.
     */
    trailer_len = auth_len + RPC_CN_PKT_SIZEOF_COM_AUTH_TLR;
    stub_length = frag_len - trailer_len - hdr_len;

    /*
     * Copy the header and the stub data into out_iov.
     * Note that we can avoid the copy if we get 0 length stub data.
     */
    rpc__krb_cn_coalesce_fragbufs (iov, iovlen-1, out_iov);
		    if (out_iov->base == NULL)
			return;
    byte_ptr = out_iov->base;
    byte_ptr += out_iov->len;

    /*
     * pkt now points to the copied packet, not the original.
     * Update the frag_len and auth_len fields.
     */
    pkt = (rpc_cn_packet_p_t) out_iov->base;
    RPC_CN_PKT_FRAG_LEN (pkt) = frag_len;
    RPC_CN_PKT_AUTH_LEN (pkt) = auth_len;

    /*
     * If there is stub data,  pad it with the right number of nulls, 
     * concatenate an octet containing the pad length, and concatenate
     * the crc.
     */

    if (stub_length > 0)
    {
        /*
         * According to the architecture spec this padding is 3 mod
         * 8. 
         */
        pad_length = (11 - (stub_length & 0x07)) & 0x07;

        /*
         * Update the frag_len for the padding,
         * 1 byte for the pad_length, and 4 for the crc.
	 * Since the header has already been copied, we are
	 * updating it in the copy.
         */
        RPC_CN_PKT_FRAG_LEN (pkt) += (pad_length + 5);
        out_iov->len += (pad_length + 5);

	for (i=pad_length; i>0; i--)
        {
            *byte_ptr++ = (unsigned8) 0;
        }
        *byte_ptr++ = (unsigned8) pad_length;

        /*
         * stub_length now includes the pad bytes plus the
         * pad count.
	 */
        stub_length += pad_length + 1;

        /*
         * Compute crc of stub body, concatenate to padded PDU.
         */
        stub = (unsigned8 *) out_iov->base;
        stub += hdr_len;
        int_ptr = (unsigned32 *) byte_ptr;
        *int_ptr = rpc__krb_crc (0, stub, stub_length);
        byte_ptr += 4;

        /*
         * stub_length now includes the original stub data, the 
         * pad bytes, the pad count, plus the crc.
         */
        stub_length += 4;

    }

    /*
     * Compute strong checksum of message header.
     */
    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
    {
        rpc__krb_cn_compute_ivec (assoc_sec, 
	    RPC_CN_TRANSMIT,
	    (boolean32) sec->sec_info->is_server,
	    &ivec);
        sec_des_cbc_cksum (
            (sec_des_block *) out_iov->base, 
	    &checksum_temp,
	    hdr_len,
	    krb_cn_info->key_sched, 
	    &ivec);
    }
    else
    {
        rpc__krb_cn_compute_md5_cksm ((byte_p_t)out_iov->base,
                                      hdr_len, 
                                      &(krb_cn_info->encrypted_crc), 
                                      assoc_sec, 
                                      RPC_CN_TRANSMIT,
                                      sec->sec_info->is_server,
                                      checksum_md_temp);
    }

    /*
     * Now copy the authentication trailer.
     */
    auth_tlr = (rpc_cn_auth_tlr_t *)byte_ptr;
    memcpy (auth_tlr, iov[iovlen-1].base, trailer_len);
    out_iov->len = out_iov->len + trailer_len;
    auth_value = (rpc_cn_auth_value_priv_t *) (auth_tlr->auth_value);


#define RPC_KRB_CN_CKSUM_COPY(cksum_src, cksum_dst)\
{\
    memcpy (cksum_dst, cksum_src, krb_cn_info->auth_cksm_len);\
}

    /*
     * If there is a stub body, encrypt padded stub body (in place)
     * using checksum_temp as IV.
     * Then insert 0 into the authentication trailer.
     */
    if (stub_length > 0)
    {
        if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE_MD5)
        {
            /*
             * Make an 8-byte value by exclusive or-ing the two halves
             * of the 16-byte value.
             */
            for (i = 0; i < sizeof(sec_des_block); i++)
            {
                checksum_md_temp[i] = checksum_md_temp[i] ^ 
                    checksum_md_temp[i + sizeof(sec_des_block)];
            }
            memcpy (&checksum_temp, checksum_md_temp, sizeof(sec_des_block));
        }
#ifndef NOENCRYPTION
	sec_des_cbc_encrypt ((sec_des_block *) stub, 
                             (sec_des_block *) stub, 
                             stub_length, 
                             krb_cn_info->key_sched,
	                     &checksum_temp, 
                             sec_des_encrypt);
#endif
	RPC_KRB_CN_CKSUM_COPY (md_zero_block, (sec_des_block *) auth_value->checksum);
    }
    else
    {
        /*
         * If there is no stub body, insert checksum_tmp
         * into the authentication trailer.
         */
        if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE_MD5)
	{
            RPC_KRB_CN_CKSUM_COPY (checksum_md_temp, 
				  (sec_des_block *) auth_value->checksum);
        }
        else
        {
            RPC_KRB_CN_CKSUM_COPY (&checksum_temp, 
	        (sec_des_block *) auth_value->checksum);
        }
    }

}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_privacy_decode_pkt
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine will perform receive-check processing on
**      a packet protected at auth level privacy.  
**      This routine will decrypt the stub data and verify
**      the checksum.
**
**  INPUTS:
**
**      assoc_sec       A pointer to per-association security context
**                      including association UUID CRC and sequence numbers.
**      sec             A pointer to security context element which includes
**                      the key ID, auth information rep and RPC auth
**                      information rep.
**      pdu             A pointer to the PDU received.
**      pdu_len         The length, in bytes, of the PDU.
**      auth_tlr        A pointer to the auth trailer in the pdu.  This
**                      is useful since the pdu may be in an endian format
**                      different from the machine on which we're executing.
**      unpack_ints     A boolean indicating whether integers within the
**                      pdu need to be unpacked because of endian
**                      differences.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_privacy_decode_pkt 
(
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    rpc_cn_sec_context_p_t          sec,
    rpc_cn_packet_p_t               pdu,
    unsigned32                      pdu_len,
    rpc_cn_auth_tlr_p_t             auth_tlr,
    boolean32                       unpack_ints,
    unsigned32                      *st
)
{
    unsigned32                 ptype, pad_len, i;
    unsigned16		       hdr_len, trailer_len, stub_length;
    unsigned16                 frag_len, pdu_frag_len;
    unsigned32		       local_crc;
    unsigned32                 *crc_ptr;
    unsigned8		       *stub, *byte_ptr, *pad_byte_ptr;
    sec_des_block	       checksum_temp, ivec;
    idl_byte                   checksum_md_temp[RPC_C_CN_DCE_MD5_CKSM_LEN];
    rpc_cn_auth_value_priv_p_t auth_value;
    rpc_krb_cn_info_t          *krb_cn_info;


    krb_cn_info = (rpc_krb_cn_info_p_t)sec->sec_cn_info;

    /*
     * Figure out the size of the header.
     */
    ptype = RPC_CN_PKT_PTYPE(pdu);
    switch ((int)ptype)
    {
	case RPC_C_CN_PKT_REQUEST:
	    hdr_len = RPC_CN_PKT_SIZEOF_RQST_HDR_NO_OBJ;
	    if (RPC_CN_PKT_OBJ_UUID_PRESENT(pdu))
	    {
		hdr_len = RPC_CN_PKT_SIZEOF_RQST_HDR_W_OBJ;
	    }
	    break;

	case RPC_C_CN_PKT_RESPONSE:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_RESP_HDR;
	    break;
	}
	case RPC_C_CN_PKT_FAULT:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_FAULT_HDR;
	    break;
	}
        case RPC_C_CN_PKT_SHUTDOWN:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_SHUTDOWN_HDR;
	    break;
	}
        case RPC_C_CN_PKT_REMOTE_ALERT:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_ALERT_HDR;
	    break;
	}
        case RPC_C_CN_PKT_ORPHANED:
	{
	    hdr_len = RPC_CN_PKT_SIZEOF_ORPHANED_HDR;
	    break;
	}
	default:
	{
	    /*
	     * rpc_m_bad_pkt_type
	     * "(%s) Illegal or unknown packet type: %x"
	     */
	    RPC_DCE_SVC_PRINTF ((
		DCE_SVC(RPC__SVC_HANDLE, "%s%x"),
		rpc_svc_auth,
		svc_c_sev_fatal | svc_c_action_abort,
		rpc_m_bad_pkt_type,
		"rpc__krb_cn_privacy_decode_pkt",
		(int)ptype ));
	    break;
	}
    }

    auth_value = (rpc_cn_auth_value_priv_t *)(auth_tlr->auth_value);

    /*
     * If there is a stub body, compute how much padding we need 
     * to bring the stub data to a 3 mod 8 boundary.
     */
    trailer_len = RPC_CN_PKT_AUTH_LEN (pdu);
    if (unpack_ints)
    {
        SWAB_INPLACE_16 (trailer_len);
    }
    trailer_len += RPC_CN_PKT_SIZEOF_COM_AUTH_TLR;
    stub_length = RPC_CN_PKT_FRAG_LEN (pdu);
    if (unpack_ints)
    {
        SWAB_INPLACE_16 (stub_length);
    }
    stub_length = stub_length - trailer_len - hdr_len;

    /*
     * Compute strong checksum of message header.
     */
    if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
    {
        rpc__krb_cn_compute_ivec (assoc_sec, 
	    RPC_CN_RECEIVE,
	    ! (sec->sec_info->is_server),
	    &ivec);
        sec_des_cbc_cksum (
            (sec_des_block *) pdu, 
	    &checksum_temp,
	    hdr_len,
	    krb_cn_info->key_sched, 
	    &ivec);
    }
    else
    {
        rpc__krb_cn_compute_md5_cksm ((byte_p_t)pdu,
                                      hdr_len,
                                      &(krb_cn_info->encrypted_crc),
                                      assoc_sec, 
                                      RPC_CN_RECEIVE,
                                      ! (sec->sec_info->is_server),
                                      checksum_md_temp);
    }

    /*
     * If there is no stub data, verify that checksum in the 
     * authentication trailer matches & we are done.
     */
    if (stub_length == 0)
    {
        if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
        {
	    if (! rpc__krb_cn_des_cksum_eq (
	       (sec_des_block *)auth_value->checksum,
	       &checksum_temp))
            {
	        *st = rpc_s_invalid_checksum;
	        return;
            }
        }
        else
        {
	    if (! rpc__krb_cn_md_cksum_eq (
	       (idl_byte *)(auth_value->checksum),
	       (idl_byte *)(checksum_md_temp)))
            {
	        *st = rpc_s_invalid_checksum;
	        return;
            }
        }
    }
    else
    {
        /*
	 * There is stub data.
	 *
         * First, verify that the checksum is 0.
	 */
        if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE)
        {
	    if (! rpc__krb_cn_des_cksum_eq (
	       (sec_des_block *)auth_value->checksum,
	       &zero_block))
            {
	        *st = rpc_s_invalid_checksum;
	        return;
            }
        }
        else
        {
	    if (! rpc__krb_cn_md_cksum_eq (
	       auth_value->checksum,
	       md_zero_block))
            {
	        *st = rpc_s_invalid_checksum;
	        return;
            }
        }
	/*
	 * Decrypt the stub body.
         */
        stub = (unsigned8 *) pdu;
        stub += hdr_len;

        if (krb_cn_info->auth_subtype == RPC_C_CN_DCE_SUB_TYPE_MD5)
        {
            /*
             * Make an 8-byte value by exclusive or-ing the two halves
             * of the 16-byte value.
             */
            for (i = 0; i < sizeof(sec_des_block); i++)
            {
                checksum_md_temp[i] = checksum_md_temp[i] ^ 
                    checksum_md_temp[i + sizeof(sec_des_block)];
            }
            memcpy (&checksum_temp, checksum_md_temp, sizeof(sec_des_block));
        }
#ifndef NOENCRYPTION
	sec_des_cbc_encrypt ((sec_des_block *) stub, 
                             (sec_des_block *) stub, 
                             stub_length, 
                             krb_cn_info->key_sched,
	                     &checksum_temp, 
                             sec_des_decrypt);
#endif

        /*
         * Get pointer into the 4 byte crc and the pad byte offsets.
	 */
        byte_ptr = (unsigned8 *) pdu;
	byte_ptr += hdr_len + stub_length - 4;
	crc_ptr = (unsigned32 *) byte_ptr;
        pad_byte_ptr = --byte_ptr;

        /*
         * Verify the crc.
	 * First, shorten stub length to account for the crc.
	 */
        stub_length -= 4;
	local_crc = rpc__krb_crc (0, stub, stub_length);
        if (unpack_ints)
        {
            SWAB_INPLACE_32 (local_crc);
        }
        if (local_crc != *crc_ptr)
	{
	    *st = rpc_s_invalid_crc;
	    return;
	}

	/*
         * Now adjust the frag_len to remove any padding,
	 * the byte for the pad_length, and the 4 bytes of the crc.
	 * Also move the auth_tlr up to fill the gap.
	 */
	pad_len = *pad_byte_ptr + 5;
        pdu_frag_len = RPC_CN_PKT_FRAG_LEN (pdu);
        if (unpack_ints)
        {
            SWAB_INPLACE_16 (pdu_frag_len);
        }
        frag_len = pdu_frag_len -= pad_len;

        /*
         * Put frag length back into sender's format since the
         * entire packet will be byte-swapped later.
         */
        if (unpack_ints)
        {
            SWAB_INPLACE_16 (pdu_frag_len);
        }
        RPC_CN_PKT_FRAG_LEN (pdu) = pdu_frag_len;

        /*
         * Pull up the auth trailer to be contiguous with the stub
         * data. All the macros to access the auth trailer assume
         * the auth trailer directly follows the stub data.
         */
	byte_ptr = (unsigned8 *) pdu;
	byte_ptr += frag_len - trailer_len;
	memcpy (byte_ptr, auth_tlr, trailer_len);
    }
    *st = rpc_s_ok;
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_inq_cksum_algorithm
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine determines the checksum algorithm to be used
**      (currently either DES or MD5) when encoding a packet by
**      inspecting the value of an environment variable.  If the 
**      variable is not set, the default algorithm is selected.  
**      If the variable is set to an invalid or unsupported value, 
**      an error code is returned.
**
**      This routine is called from rpc__krb_cn_init.
**      The checksum algorithm information is placed in a global
**      variable for use by other connection-oriented security
**      routines.  This implementation choice means that the chosen
**      algorithm will have a lifetime equal to the lifetime of the
**      process.  This approach minimizes the amount of overhead
**      for deciding what algorithm to use.
**
**  INPUTS:             none
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:            
**
**      st              The return status of this routine.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:
**
**      rpc_g_krb_cn_sub_type      Global representing the value of
**                                 RPC_CN_AUTH_SUBTYPE at the time
**                                 this routine was called.
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_inq_cksum_algorithm 
(
    unsigned32                      *st
)
{
    unsigned_char_p_t           subtype_string;
    unsigned32                  subtype;
    

    subtype_string = (unsigned_char_p_t) getenv ("RPC_CN_AUTH_SUBTYPE");
    if (subtype_string == NULL)
    {
        /*
         * Nothing set in the environment, so use the default.
         */
        rpc_g_krb_cn_sub_type = RPC_C_CN_DCE_SUB_TYPE_MD5;
        *st = rpc_s_ok;
    }
    else
    {
        /*
         * Use the value of the enviroment variable, if valid, otherwise
         * set to the default and return bad status.
         */
        subtype = (unsigned32) (atoi ((char*)subtype_string));
        switch ((int)subtype)
        {
            case RPC_C_CN_DCE_SUB_TYPE:
            case RPC_C_CN_DCE_SUB_TYPE_MD5:
            {
                rpc_g_krb_cn_sub_type = subtype;
                *st = rpc_s_ok;
                break;
            }
            default:
            {
                rpc_g_krb_cn_sub_type = RPC_C_CN_DCE_SUB_TYPE_MD5;
                *st = rpc_s_unsupported_auth_subtype;
                break;
            }
        }
    }    
}


/*****************************************************************************/
/*
**++
**
**  ROUTINE NAME:       rpc__krb_cn_compute_md5_cksm
**
**  SCOPE:              INTERNAL - declared locally
**
**  DESCRIPTION:
**      
**      This routine computes a md5 checksum based on its input args.
**
**  INPUTS:             
**
**      plaintext       Pointer to the message to be checksummed.
**
**      plaintext_len   The length of the plaintext.
**
**      encrypted_crc   Pointer to the encrypted crc for this association.
**
**      assoc_sec       Pointer to the rpc_cn_assoc_sec_context.
**
**      is_transmitter  Boolean which determines whether the send or
**                      receive sequence number will be used.
**
**      is_server       Boolean indicating whether the checksum should
**                      be computed from the server's or client's point
**                      of view.  Note that when verifying a checksum,
**                      a server should compute the checksum as if it
**                      were the client.
**
**  INPUTS/OUTPUTS:     none
**
**  OUTPUTS:
**
**      checksum        Pointer where the checksum will be placed.
**
**  IMPLICIT INPUTS:    none
**
**  IMPLICIT OUTPUTS:   none
**
**  FUNCTION VALUE:     none
**
**  SIDE EFFECTS:       none
**
**--
**/

INTERNAL void rpc__krb_cn_compute_md5_cksm 
(
    byte_p_t                        plaintext,
    unsigned32                      plaintext_len,
    sec_des_block                   *encrypted_crc,
    rpc_cn_assoc_sec_context_p_t    assoc_sec,
    boolean32                       is_transmitter,
    boolean32                       is_server,
    idl_byte                        *checksum
)
{
    sec_md_struct               mdstate;
    unsigned32                  sequence_number;

    sec_md_begin (&mdstate);
    sec_md_update (&mdstate, (byte_p_t)plaintext, plaintext_len);
    sec_md_update (&mdstate, (byte_p_t)(encrypted_crc),
                   sizeof (*encrypted_crc));

    /*
     * Get the 32-bit crypto sequence number.
     * Flip the msb of the 32 sequence number if the message
     * is from the server to the client.  Adjust the result to be
     * little endian, then add it to the digest.
     */

    if (is_transmitter)
    {
        sequence_number = assoc_sec->assoc_next_snd_seq;
    }
    else
    {
        sequence_number = assoc_sec->assoc_next_rcv_seq;
    }

    if (is_server)
    {
	sequence_number ^= (unsigned32)0x80000000;
    }

    if (NDR_LOCAL_INT_REP != ndr_c_int_little_endian)
    {
	SWAB_INPLACE_32 (sequence_number);
    }

    sec_md_update (&mdstate, (byte_p_t)(&sequence_number),
                   sizeof (sequence_number));

    /*
     * Finish the message digest and copy to the output area.
     */
    sec_md_final (&mdstate);
    memcpy (checksum, mdstate.digest, RPC_C_CN_DCE_MD5_CKSM_LEN);
}
